/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.mannheim.uni.tableprocessor.statistics;

import de.mannheim.uni.tableprocessor.IO.TableReader;
import de.mannheim.uni.tableprocessor.model.Table;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

/**
 *
 * @author domi
 */
public class Statistics {

    public static void main(String args[]) throws UnsupportedEncodingException, FileNotFoundException, IOException {

        String fileDir = args[0];
        File dir = new File(fileDir);
        BufferedWriter write = new BufferedWriter(new FileWriter("sizes.csv"));

        for (File f : dir.listFiles()) {
            TableReader read = new TableReader();
            Table t = read.readWebTable(f.getAbsolutePath());
            int size;
            if (t.getKey() == null) {
                size = -1;
            } else {
                size = t.getKey().getValues().size();
            }

            write.write(f.getName() + ";" + size + "\n");
        }
        write.flush();
        write.close();
    }
}
