package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import de.mannheim.uni.matching.dbpedia.LuceneBlocking;
import de.mannheim.uni.matching.dbpedia.algorithm.KeyIndex;
import de.mannheim.uni.matching.dbpedia.model.TableRow;

public class RepositoryKeyIndex extends KeyIndex {

	private ThreadLocal<LuceneBlocking<TableRow>> luceneBlocking = new ThreadLocal<>();

	public LuceneBlocking<TableRow> getLuceneBlocking() {
		return luceneBlocking.get();
	}

	public void setLuceneBlocking(LuceneBlocking<TableRow> luceneBlocking) {
		this.luceneBlocking.set(luceneBlocking);
	}

}
