package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

public class AnnotatedTablesReaderData implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final AnnotatedTableId id;
	private final AnnotatedTableMetaData metaData;
	private final AnnotatedTable tableData;

	public AnnotatedTablesReaderData(AnnotatedTableId id, AnnotatedTableMetaData metaData, AnnotatedTable tableData) {
		super();
		this.id = id;
		this.metaData = metaData;
		this.tableData = tableData;
	}

	public AnnotatedTableId getId() {
		return id;
	}

	public AnnotatedTableMetaData getMetaData() {
		return metaData;
	}

	public AnnotatedTable getTableData() {
		return tableData;
	}

}