package de.mannheim.uni.expansion.data.tables.reader;

import java.io.IOException;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId.FileEnding;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;

public interface AnnotatedTableParser {

	AnnotatedTableMetaData getMetaData(byte[] content, String name, FileEnding fileEnding) throws IOException, InvalidTableException;

	int getColumnCount();

	AnnotatedTablesReaderData get(byte[] content, String name, FileEnding fileEnding) throws IOException, InvalidTableException;

}
