package de.uni_mannheim.informatik.dws.expansion.evaluation;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;

public class FilteredValues {

	private final int set;
	private final KnowledgeBase dbBpediaRepository;
	private final double percent;

	public FilteredValues(KnowledgeBase dbBpediaRepository, double percent, int set) {
		this.dbBpediaRepository = dbBpediaRepository;
		this.percent = percent;
		this.set = set;

	}

	@Deprecated
	public Set<AbstractObject> getFilteredValues(TripleId tid) {

		QualifiedValueList value = dbBpediaRepository.getQualifiedValueList(new ValueId(tid.getInstanceId(), tid.getPropertyId()));

		if (value.isList()) {

			Set<AbstractObject> ret = new HashSet<>();

			List<AbstractObject> values = value.getClaims().stream().map((e) -> {
				return e.getValue();
			}).collect(Collectors.toList());

			double filterSize = percent * values.size();

			int currentSet = set;

			int s = (int) Math.round(Math.ceil(filterSize * currentSet));

			int sEnd = (int) Math.round(filterSize * (currentSet + 1));

			for (int i = s; i < sEnd; i++) {
				ret.add(values.get(i));
			}

			return ret;
			// for (Object v : values) {
			//
			// if (s >= sEnd) {
			// currentSet++;
			// sEnd = filterSize * (currentSet + 1);
			// }
			//
			// CHMHelper.getFromMap(filteredValues, currentSet, () -> new
			// HashSet<>()).add(v);
			//
			// s++;
			//
			// }
			//
			// for (Entry<Integer, Set<Object>> e2 : filteredValues.entrySet())
			// {
			// CHMHelper.getFromCHM(creationMap, e2.getKey(), () -> new
			// ConcurrentHashMap<>()).put(tid, e2.getValue());
			//
			// }

		}

		return null;

	}
}