package de.uni_mannheim.informatik.dws.attribute.matcher;

public class AttributeThresholdLearner {
	//
	// private final AttributeMatcher matcher;
	// private final AttributeMappingsEvaluator evaluator;
	//
	// @Inject
	// public AttributeThresholdLearner(AttributeMatcher matcher,
	// AttributeMappingsEvaluator evaluator) {
	// super();
	// this.matcher = matcher;
	// this.evaluator = evaluator;
	// }
	//
	// public ThresholdContainer findThreshold(List<AnnotatedTablesReaderData>
	// tables, Map<ClassId, Set<PropertyId>> nonTailProperties,
	// AttributeMappings gs,
	// int setCounts, Function<AnnotatedTableId, ClassId> tableClassGetter) {
	// double step = 0.05;
	// int stepsCount = 20;
	//
	// Collections.shuffle(tables);
	//
	// Map<Integer, List<AnnotatedTablesReaderData>> splitMap = new HashMap<>();
	// {
	// int set = 0;
	// for (AnnotatedTablesReaderData table : tables) {
	// CHMHelper.getFromMap(splitMap, set, () -> new ArrayList<>()).add(table);
	// }
	// set++;
	// if (set == setCounts) {
	// set = 0;
	// }
	// }
	//
	// ConcurrentHashMap<ClassPropertyId, Map<Integer, Double>> thresholds = new
	// ConcurrentHashMap<>();
	//
	// for (Entry<Integer, List<AnnotatedTablesReaderData>> splitEntry :
	// splitMap.entrySet()) {
	//
	// ConcurrentHashMap<ClassPropertyId, ConcurrentLinkedQueue<Double>>
	// correctMap = new ConcurrentHashMap<>();
	// ConcurrentHashMap<ClassPropertyId, ConcurrentLinkedQueue<Double>>
	// wrongMap = new ConcurrentHashMap<>();
	// ConcurrentHashMap<ClassPropertyId, AtomicInteger> maxCorrect = new
	// ConcurrentHashMap<>();
	//
	// PersistentParallel6.runAndFinish(splitEntry.getValue(), (table) -> {
	//
	// for (ColumnIdx columnIdx : table.getTableData().getColumns()) {
	// Map<PropertyId, Double> highestMatches =
	// matcher.getHighestMatchesOld(table.getMetaData().getDbPediaClass(),
	// nonTailProperties.get(table.getMetaData().getDbPediaClass()),
	// table.getMetaData().getInstances(),
	// table.getMetaData().getInstancesScores(),
	// table.getTableData().getColumn(columnIdx),
	// table.getTableData().getDataType(columnIdx));
	//
	// Optional<PropertyId> gsMapping = gs.getMapping(table.getId(), columnIdx);
	//
	// for (Entry<PropertyId, Double> matchEntry : highestMatches.entrySet()) {
	// if (gsMapping.isPresent() && gsMapping.get().equals(matchEntry.getKey()))
	// {
	// CHMHelper.getFromCHM(correctMap, new
	// ClassPropertyId(table.getMetaData().getDbPediaClass(),
	// matchEntry.getKey()),
	// () -> new ConcurrentLinkedQueue<>()).add(matchEntry.getValue());
	// } else {
	// CHMHelper.getFromCHM(wrongMap, new
	// ClassPropertyId(table.getMetaData().getDbPediaClass(),
	// matchEntry.getKey()),
	// () -> new ConcurrentLinkedQueue<>()).add(matchEntry.getValue());
	// }
	// }
	//
	// if (gsMapping.isPresent()) {
	// CHMHelper.getFromCHM(maxCorrect, new
	// ClassPropertyId(table.getMetaData().getDbPediaClass(), gsMapping.get()),
	// () -> new AtomicInteger())
	// .incrementAndGet();
	// }
	// }
	// }, this.getClass());
	//
	// Set<ClassPropertyId> propertiesSet = new HashSet<>();
	// propertiesSet.addAll(correctMap.keySet());
	// propertiesSet.addAll(wrongMap.keySet());
	//
	// for (ClassPropertyId cpid : propertiesSet) {
	// ConcurrentLinkedQueue<Double> correctList = correctMap.get(cpid);
	// ConcurrentLinkedQueue<Double> wrongList = wrongMap.get(cpid);
	//
	// Double maxThreshold = null;
	// double fmeasure = 0.0;
	// for (int i = 0; i <= stepsCount; i++) {
	// double threshold = i * step;
	// int correct = 0;
	// int wrong = 0;
	// if (correctList != null) {
	// for (Double score : correctList) {
	// if (score >= threshold) {
	// correct++;
	// }
	// }
	// }
	//
	// if (wrongList != null) {
	// for (Double score : wrongList) {
	// if (score >= threshold) {
	// wrong++;
	// }
	// }
	// }
	//
	// AttributeMappingsPerformance performance = new
	// AttributeMappingsPerformance(correct, wrong,
	// maxCorrect.getOrDefault(cpid, new AtomicInteger()).get());
	// if (maxThreshold == null || performance.getfMeasure() > fmeasure) {
	// maxThreshold = threshold;
	// fmeasure = performance.getfMeasure();
	// }
	// }
	//
	// CHMHelper.getFromCHM(thresholds, cpid, () -> new
	// HashMap<>()).put(splitEntry.getKey(), maxThreshold);
	// }
	// }
	//
	// Map<ClassPropertyId, Double> thresholdsSummed =
	// thresholds.entrySet().stream().collect(Collectors.toMap(Entry::getKey,
	// (e) -> {
	// return
	// e.getValue().values().stream().mapToDouble(Double::doubleValue).average().getAsDouble();
	// }));
	//
	// return new ThresholdClassPropertyId(thresholdsSummed);
	// }
	//
	// public ThresholdContainer
	// findThresholdClassId(List<AnnotatedTablesReaderData> tables, Map<ClassId,
	// Set<PropertyId>> nonTailProperties,
	// AttributeMappings gs, int setCounts, Function<AnnotatedTableId, ClassId>
	// tableClassGetter) {
	// Map<ClassId, List<AnnotatedTablesReaderData>> byClass = new HashMap<>();
	//
	// for (AnnotatedTablesReaderData table : tables) {
	// CHMHelper.getFromMap(byClass, tableClassGetter.apply(table.getId()), ()
	// -> new ArrayList<>()).add(table);
	// }
	//
	// Map<ClassId, Double> thresholds = new HashMap<>();
	// for (Entry<ClassId, List<AnnotatedTablesReaderData>> entry :
	// byClass.entrySet()) {
	// Double threshold = findThreshold(entry.getValue(), nonTailProperties, gs,
	// setCounts);
	// thresholds.put(entry.getKey(), threshold);
	//
	// }
	//
	// return new ThresholdClassId(thresholds);
	//
	// }
	//
	// private Double findThreshold(List<AnnotatedTablesReaderData> tables,
	// Map<ClassId, Set<PropertyId>> nonTailProperties, AttributeMappings gs,
	// int setCounts) {
	// double step = 0.05;
	// int stepsCount = 20;
	//
	// Collections.shuffle(tables);
	//
	// Map<Integer, List<AnnotatedTablesReaderData>> splitMap = new HashMap<>();
	// {
	// int set = 0;
	// for (AnnotatedTablesReaderData table : tables) {
	// CHMHelper.getFromMap(splitMap, set, () -> new ArrayList<>()).add(table);
	// }
	// set++;
	// if (set == setCounts) {
	// set = 0;
	// }
	// }
	//
	// Map<Integer, Double> thresholds = new ConcurrentHashMap<>();
	//
	// for (Entry<Integer, List<AnnotatedTablesReaderData>> splitEntry :
	// splitMap.entrySet()) {
	//
	// ConcurrentLinkedQueue<Double> correctList = new
	// ConcurrentLinkedQueue<>();
	// ConcurrentLinkedQueue<Double> wrongList = new ConcurrentLinkedQueue<>();
	// AtomicInteger maxCorrect = new AtomicInteger();
	//
	// PersistentParallel6.runAndFinish(splitEntry.getValue(), (table) -> {
	//
	// for (ColumnIdx columnIdx : table.getTableData().getColumns()) {
	// Optional<Pair<PropertyId, Double>> highestMatches =
	// matcher.getMatchWithScore(table.getMetaData().getDbPediaClass(),
	// nonTailProperties.get(table.getMetaData().getDbPediaClass()),
	// table.getMetaData().getInstances(),
	// table.getMetaData().getInstancesScores(),
	// table.getTableData().getColumn(columnIdx),
	// table.getTableData().getDataType(columnIdx));
	//
	// Optional<PropertyId> gsMapping = gs.getMapping(table.getId(), columnIdx);
	//
	// if (highestMatches.isPresent()) {
	// if (gsMapping.isPresent() &&
	// gsMapping.get().equals(highestMatches.get().getFirst())) {
	// correctList.add(highestMatches.get().getSecond());
	// } else {
	// wrongList.add(highestMatches.get().getSecond());
	// }
	// }
	//
	// if (gsMapping.isPresent()) {
	// maxCorrect.incrementAndGet();
	// }
	// }
	// }, this.getClass());
	//
	// Double maxThreshold = null;
	// double fmeasure = 0.0;
	// for (int i = 0; i <= stepsCount; i++) {
	// double threshold = i * step;
	// int correct = 0;
	// int wrong = 0;
	// if (correctList != null) {
	// for (Double score : correctList) {
	// if (score >= threshold) {
	// correct++;
	// }
	// }
	// }
	//
	// if (wrongList != null) {
	// for (Double score : wrongList) {
	// if (score >= threshold) {
	// wrong++;
	// }
	// }
	// }
	//
	// AttributeMappingsPerformance performance = new
	// AttributeMappingsPerformance(correct, wrong, maxCorrect.get());
	// if (maxThreshold == null || performance.getfMeasure() > fmeasure) {
	// maxThreshold = threshold;
	// fmeasure = performance.getfMeasure();
	// }
	// }
	//
	// thresholds.put(splitEntry.getKey(), maxThreshold);
	//
	// }
	//
	// Double thresholdsSummed =
	// thresholds.values().stream().mapToDouble(Double::doubleValue).average().getAsDouble();
	//
	// return thresholdsSummed;
	// }

}
