package de.uni_mannheim.informatik.dws.attribute.model;

import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.utils.ImmuMaker;

public class TableAttributeMappings {
	private final Map<ColumnIdx, PropertyMapping> mappings;

	public TableAttributeMappings(Map<ColumnIdx, PropertyMapping> mappings) {
		this.mappings = ImmuMaker.map(mappings);
	}

	public Map<ColumnIdx, PropertyMapping> getMappings() {
		return mappings;
	}

}
