package de.uni_mannheim.dws.expansion.data.ontology.model.types;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;

public class WikidataParsedItem extends WikidataParsedObject {

	private final InstanceId instanceId;

	public WikidataParsedItem(Map<PropertyId, QualifiedValueList> valuesMap, String label, Map<String, String> labels, Map<String, Set<String>> aliases,
			InstanceId instanceId) {
		super(valuesMap, label, labels, aliases);
		this.instanceId = instanceId;
	}

	public InstanceId getInstanceId() {
		return instanceId;
	}
}
