package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.io.IOException;

import de.mannheim.uni.expansion.tablefusion.core.similarity.measures.matching.MatchingStringSimilarityWithSurfaceForms;
import de.mannheim.uni.expansion.tablefusion.modules.AbstractsModule;
import de.mannheim.uni.expansion.tablefusion.modules.SimilarityModule;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.SimpleLockableConcurrentCache;
import de.uni_mannheim.informatik.dws.expansion.matching.KnowledgeBaseModule;

public class BlockingAndNonBlockingTest {

	public static void log(String log) {
		System.out.println("PIPELINE_MESSAGE: " + log);
	}

	public static void main(String[] args) throws IOException {
		KnowledgeBaseModule.CACHE_KEY_INDEX_STATICALLY = true;
		AbstractsModule.CACHE_ABSTRACTS_STATICALLY = true;
		SimilarityModule.CACHE_NUMERIC_RANGE_STATICALLY = true;
		int totalRuns = 1;

		for (int currentRun = 1; currentRun <= totalRuns; currentRun++) {

			String disableBlocking = null;
			do {
				if (disableBlocking == null) {
					disableBlocking = "true";
				} else {
					disableBlocking = "false";
				}
				disableBlocking = "false";

				if (false) {
					disableBlocking = "true";
					log("" + currentRun + "a -   Blocking Performance Run, with blocking" + (disableBlocking.equals("true") ? "NO" : "YES"));
					GSRun.main(new String[] { args[0], args[1], args[2], "true", "true", String.valueOf(currentRun), disableBlocking });
					PersistentParallel6.restart();
					SimpleLockableConcurrentCache.clearAllCaches();
				}

				disableBlocking = "false";

				if (disableBlocking.equals("false")) {
					log("" + currentRun + "b -   Full Run, with blocking" + (disableBlocking.equals("true") ? "NO" : "YES"));
					if (args.length > 3) {
						if (args[3].equals("1")) {
							System.out.println("DISABLED SURFACE FORMS");
							MatchingStringSimilarityWithSurfaceForms.NO_SURFACE_FORMS = true;
						}
						FullRun.main(new String[] { args[0], args[1], args[2], "true", "true", String.valueOf(currentRun), disableBlocking, args[3] });
					} else
						FullRun.main(new String[] { args[0], args[1], args[2], "true", "true", String.valueOf(currentRun), disableBlocking });

					if (true)
						return;

					PersistentParallel6.restart();
					SimpleLockableConcurrentCache.clearAllCaches();

					int sdf = 123;
				}

				int sdf = 123;

			} while (disableBlocking != null && disableBlocking.equals("true"));

		}

		try {
			PersistentParallel6.close();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
