package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class PropertyConstants {
	public static final PropertyId team = new PropertyId("http://dbpedia.org/ontology/team");
	public static final PropertyId position = new PropertyId("http://dbpedia.org/ontology/position");

	public static final PropertyId formerTeam = new PropertyId("http://dbpedia.org/ontology/formerTeam");
	public static final PropertyId debutTeam = new PropertyId("http://dbpedia.org/ontology/debutTeam");

	public static final PropertyId artist = new PropertyId("http://dbpedia.org/ontology/artist");
	public static final PropertyId college = new PropertyId("http://dbpedia.org/ontology/college");
	public static final PropertyId musicalArtist = new PropertyId("http://dbpedia.org/ontology/musicalArtist");
	public static final PropertyId musicalBand = new PropertyId("http://dbpedia.org/ontology/musicalBand");

	public static final PropertyId draftPick = new PropertyId("http://dbpedia.org/ontology/draftPick");
	public static final PropertyId draftYear = new PropertyId("http://dbpedia.org/ontology/draftYear");
	public static final PropertyId draftRound = new PropertyId("http://dbpedia.org/ontology/draftRound");
	public static final PropertyId number = new PropertyId("http://dbpedia.org/ontology/number");

	public static final PropertyId runtime = new PropertyId("http://dbpedia.org/ontology/runtime");
	public static final PropertyId bSide = new PropertyId("http://dbpedia.org/ontology/bSide");

	public static final PropertyId workRuntime = new PropertyId("http://dbpedia.org/ontology/Work/runtime");

	public static final PropertyId height = new PropertyId("http://dbpedia.org/ontology/height");

	public static final PropertyId weight = new PropertyId("http://dbpedia.org/ontology/Person/weight");
	public static final PropertyId weightPounds = new PropertyId("http://dbpedia.org/ontology/Person/weightPounds");

	public static final PropertyId isPartOfDUL = new PropertyId("http://www.ontologydesignpatterns.org/ont/dul/DUL.owl#isPartOf");

	public static final PropertyId isPartOf = new PropertyId("http://dbpedia.org/ontology/isPartOf");

	public static final PropertyId utcOffset = new PropertyId("http://dbpedia.org/ontology/utcOffset");

	public static final PropertyId latitude = new PropertyId("http://www.w3.org/2003/01/geo/wgs84_pos#lat");

	public static final PropertyId longitude = new PropertyId("http://www.w3.org/2003/01/geo/wgs84_pos#long");

	public static final PropertyId point = new PropertyId("http://www.georss.org/georss/point");

	public static final PropertyId timeZone = new PropertyId("http://dbpedia.org/ontology/timeZone");

}
