package expansion.set.entitymatching.modelLearning;

import java.util.Map;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.GenericLearnedModelRepository;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;

public class EM_LearnedModelRepository extends GenericLearnedModelRepository<EntityMatchingModel, EM_LearnedModelRepository> {

	public EM_LearnedModelRepository() {
		super();
	}

	public EM_LearnedModelRepository(Map<OptimizableClass, EntityMatchingModel> map) {
		super(map);
	}

	@Override
	protected EM_LearnedModelRepository getFromMap(Map<OptimizableClass, EntityMatchingModel> map) {
		return new EM_LearnedModelRepository(map);
	}

}
