package expansion.set.entitymatching.modelLearning.weightsGeneric;

import java.util.List;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.containers.Tri;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepository;
import expansion.set.entitymatching.EntityMatcherEquationResult;
import expansion.set.entitymatching.EntityMatcherSingleResults;
import expansion.set.entitymatching.matchers.EntityMatcherStrategy;

public interface EM_WeightsGenericEquation {

	Tri<EntityMatcherEquationResult, InstanceId, Double> runEquation(Map<InstanceId, EntityMatcherSingleResults> candidates,
			WeightsRepository weightsRepository, OptimizableClass optimizableClass, List<EntityMatcherStrategy> entityMatcher);

	Map<InstanceId, Double> getNormalized(Map<InstanceId, EntityMatcherSingleResults> candidates, WeightsRepository weights, OptimizableClass optimizableClass,
			List<EntityMatcherStrategy> entityMatcher);

}
