package expansion.set.entitymatching.modelLearning.weka;

import com.google.common.collect.Sets;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepositoryImpl;
import expansion.set.entitymatching.matchers.EntityMatcherStrategies;
import expansion.set.entitymatching.modelLearning.EntityMatchingModelLearnerRunner;

public class ParameterLearnerEt implements ParameterableLearner {

	@Override
	public EntityMatchingModelLearnerRunner getLearner(String[] parameters) {
		return new EntityMatcherWekaLearner(
				Sets.newHashSet(EntityMatcherStrategies.ATTRIBUTE, EntityMatcherStrategies.IMPLICIT_ATTRIBUTE), "RandomForest",
				parameters, true, null, false, false, new WeightsRepositoryImpl(), true);
	}

}
