package expansion.set.entitymatching.modelLearning.weka.randomforest;

import javax.inject.Inject;

import com.google.common.collect.Sets;

import expansion.set.entitymatching.matchers.EntityMatcherStrategies;
import expansion.set.entitymatching.modelLearning.weka.EntityMatcherWekaLearner;

public class EntityMatchingWekaRFLearner extends EntityMatcherWekaLearner {
	@Inject
	public EntityMatchingWekaRFLearner() {
		super(Sets.newHashSet(EntityMatcherStrategies.ATTRIBUTE, EntityMatcherStrategies.IMPLICIT_ATTRIBUTE), "RandomForest",
				new String[] { "-N", "5", "-store-out-of-bag-predictions", "-I", "5000", "-num-slots", "12", "-K", "2" }, false,
				EntityMatcherWekaLearner.DEFAULT_UPSAMPLE);
	}
}
