package expansion.set.implicitAttributes;

import java.io.Serializable;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import de.uni_mannheim.dws.expansion.data.ontology.model.PropertyValuePair;

public class ImplicitAttributes implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Map<PropertyValuePair, Double> implicitAttributes;

	public ImplicitAttributes(Map<PropertyValuePair, Double> retMap) {
		this.implicitAttributes = Collections.unmodifiableMap(new HashMap<>(retMap));
	}

	public Map<PropertyValuePair, Double> getImplicitAttributes() {
		return implicitAttributes;
	}

}
