package expansion.set.strategies;

import expansion.set.strategies.combined.Combined_BASE;
import expansion.set.strategies.combined.Combined_RF_BASE;
import expansion.set.strategies.ea.Combined_RandomForest_ET;
import expansion.set.strategies.ea.Combined_RandomForest_ET_with_Backfitting;
import expansion.set.strategies.ea.Container_Clusterer;
import expansion.set.strategies.evaluatemethod.CLUSTERING_SIMS_AGGREGATOR;
import expansion.set.strategies.evaluatemethod.CLUSTERING_SIMS_LIST;
import expansion.set.strategies.rowclusterers.InstanceBasedClusterer;
import expansion.set.strategies.trees.Combined_RandomForest_New;

public class SetExpansionStrategiesRepository {

	
	
	public static final SetExpansionStrategy GS_CLUSTERER = new SetExpansionStrategy("GS_CLUSTERER",
			null);

	public static final SetExpansionStrategy GS_CLUSTERER_WA = new SetExpansionStrategy("GS_CLUSTERER_WA", null);

	public static final SetExpansionStrategy GS_CLUSTERER_ET = new SetExpansionStrategy("GS_CLUSTERER_ET", null);

	public static final SetExpansionStrategy GS_CLUSTERER_RF = new SetExpansionStrategy("GS_CLUSTERER_RF", null);

	public static final SetExpansionStrategy EXTERNAL = new SetExpansionStrategy("EXTERNAL", null);

	public static final SetExpansionStrategy FUSION_TESTER = new SetExpansionStrategy("FUSION_TESTER", null);


	public static SetExpansionStrategy INSTANCE_BASED_CLUSTERER = new SetExpansionStrategy("INSTANCE_BASED_CLUSTERER",
			InstanceBasedClusterer.class);
	//
	// public static SetExpansionStrategy BAG_OF_WORDS = new
	// SetExpansionStrategy("BAG_OF_WORDS",
	// BagOfWords_Strategy.class);
	//
	// public static SetExpansionStrategy BAG_OF_WORDS_WITH_TABLE = new
	// SetExpansionStrategy("BAG_OF_WORDS_WITH_TABLE",
	// BagOfWords_Table_Strategy.class);
	//
	//
	//
	// public static SetExpansionStrategy BAG_OF_WORDS_TABLE_AND_LABEL = new
	// SetExpansionStrategy("BAG_OF_WORDS_TABLE_AND_LABEL",
	// BagOfWords_Table_And_Label_Strategy.class);
	//
	// public static SetExpansionStrategy
	// BAG_OF_WORDS_TABLE_AND_LABEL_COVARIANCE = new
	// SetExpansionStrategy("BAG_OF_WORDS_TABLE_AND_LABEL_COVARIANCE",
	// BagOfWords_Table_And_Label_Strategy_Covariance_Prediction.class);
	//
	//
	// public static SetExpansionStrategy BAG_OF_WORDS_TABLE_DEVIATION = new
	// SetExpansionStrategy("BAG_OF_WORDS_TABLE_DEVIATION",
	// BagOfWords_And_Table_Deviation_Predicition.class);
	//
	//
	// public static SetExpansionStrategy BAG_OF_WORDS_TABLE_AND_LABEL_DEVIATION
	// = new SetExpansionStrategy("BAG_OF_WORDS_TABLE_AND_LABEL_DEVIATION",
	// BagOfWords_Table_And_Label_Strategy_Deviation_Prediction.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy BAG_OF_WORDS_TABLE_STOPWORDS = new
	// SetExpansionStrategy("BAG_OF_WORDS_TABLE_STOPWORDS",
	// BagOfWords_And_Table_StopWords_Strategy.class);
	//
	//
	// public static SetExpansionStrategy
	// BAG_OF_WORDS_TABLE_AND_LABEL_WITHOUT_TFIDF = new
	// SetExpansionStrategy("BAG_OF_WORDS_TABLE_AND_LABEL_WITHOUT_TFIDF",
	// BagOfWords_Table_And_Label_Strategy_without_TF_IDF.class);
	
	
	
	
	// public static SetExpansionStrategy LABEL_BLOCKED_SIMILARITY = new
	// SetExpansionStrategy("LABEL_BLOCKED_SIMILARITY",
	// LabelSimilarityClustererClassBlocked.class);
	// public static SetExpansionStrategy LABEL_UNBLOCKED_SIMILARITY = new
	// SetExpansionStrategy("LABEL_UNBLOCKED_SIMILARITY",
	// LabelSimilarityClustererClassUnblocked.class);
	// public static SetExpansionStrategy COOCCURENCE_INSTANCE_DEFAULT = new
	// SetExpansionStrategy("COOCCURENCE_INSTANCE_DEFAULT",
	// CoOccurence_Instance_DEFAULT_ClassBlocked.class);
	// public static SetExpansionStrategy COOCCURENCE_DEFAULT = new
	// SetExpansionStrategy("COOCCURENCE_DEFAULT",
	// CoOccurence_DEFAULT_ClassBlocked.class);

	// public static SetExpansionStrategy COOCCURENCE_BLOCKED_MAXSIM = new
	// SetExpansionStrategy("COOCCURENCE_BLOCKED_MAXSIM",
	// CoOccurence_MaxSim_ClassBlocked.class);
	//
	// public static SetExpansionStrategy COOCCURENCE_BLOCKED_PMI = new
	// SetExpansionStrategy("COOCCURENCE_BLOCKED_PMI",
	// CoOccurence_PMI_ClassBlocked.class);
	//
	// public static SetExpansionStrategy COOCCURENCE_BLOCKED_NPMI = new
	// SetExpansionStrategy("COOCCURENCE_BLOCKED_NPMI",
	// CoOccurence_NPMI_ClassBlocked.class);

	// public static SetExpansionStrategy ATTRIBUTE_DIRECT = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT",
	// Attribute_Direct_ClassBlocked.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_DIRECT_LABEL_WEIGHTED_AVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_LABEL_WEIGHTED_AVERAGE",
	// Attribute_Direct_ClassBlocked_WeightedAverage.class);
	//
	// public static SetExpansionStrategy ATTRIBUTE_DIRECT_LABEL_AVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_LABEL_AVERAGE",
	// Attribute_Direct_ClassBlocked_Average.class);
	//
	//
	//
	//
	//
	// public static SetExpansionStrategy ATTRIBUTE_DIRECT_LABEL_ABSMAX = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_LABEL_ABSMAX",
	// Attribute_Direct_ClassBlocked_AbsMax.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_LABEL_WEIGHTED_AVERAGE =
	// new SetExpansionStrategy("ATTRIBUTE_KBT_LABEL_WEIGHTED_AVERAGE",
	// Attribute_Direct_ClassBlocked_WeightedAverage.class);
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_LABEL_AVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_KBT_LABEL_AVERAGE",
	// Attribute_Direct_ClassBlocked_Average.class);
	//
	//
	//
	//
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_LABEL_ABSMAX = new
	// SetExpansionStrategy("ATTRIBUTE_KBT_LABEL_ABSMAX",
	// Attribute_Direct_ClassBlocked_AbsMax.class);
	//
	//
	//
	//
	//
	// public static SetExpansionStrategy
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_WEIGHTED_AVERAGE = new
	// SetExpansionStrategy("TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_WEIGHTED_AVERAGE",
	// TableJaccardInstanceNormalizedStrategy_WeightedAverage.class);
	//
	//
	// public static SetExpansionStrategy
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_AVERAGE = new
	// SetExpansionStrategy("TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_AVERAGE",
	// TableJaccardInstanceNormalizedStrategy_Average.class);
	//
	//
	//
	// public static SetExpansionStrategy
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_ABSMAX = new
	// SetExpansionStrategy("TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_ABSMAX",
	// TableJaccardInstanceNormalizedStrategy_AbsMax.class);
	//
	//
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT = new
	// SetExpansionStrategy("ATTRIBUTE_KBT", Attribute_KBT_ClassBlocked.class);
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_INSTANCE_COOCCURENCE =
	// new SetExpansionStrategy("ATTRIBUTE_KBT_INSTANCE_COOCCURENCE",
	// AttributeKBT_CoOccurence_INSTANCE_DEFAULT_BLOCKED.class);
	//
	// public static SetExpansionStrategy ATTRIBUTE_DIRECT_COOCCURENCE = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_COOCCURENCE",
	// AttributeDirect_CoOccurence_DEFAULT_BLOCKED.class);
	//
	// public static SetExpansionStrategy UNARY_KBT_AND_LABEL = new
	// SetExpansionStrategy("UNARY_KBT_AND_LABEL",
	// UnaryKBTAndLabelStrategy.class);
	//
	// public static SetExpansionStrategy UNARY_KBT = new
	// SetExpansionStrategy("UNARY_KBT", UnaryKBTStrategy.class);
	//
	// public static SetExpansionStrategy UNARY_DIRECT_AND_LABEL = new
	// SetExpansionStrategy("UNARY_DIRECT_AND_LABEL",
	// UnaryDirectAndLabelStrategy.class);
	//
	// public static SetExpansionStrategy UNARY_DIRECT = new
	// SetExpansionStrategy("UNARY_DIRECT", UnaryDirectStrategy.class);
	//
	//
	// public static SetExpansionStrategy UNARY_KBT_AND_ATTRIBUTE_KBT = new
	// SetExpansionStrategy("UNARY_KBT_AND_ATTRIBUTE_KBT",
	// UnaryKBTAndLabel_Attribute_KBT.class);
	//
	// public static SetExpansionStrategy UNARY_KBT_AND_COOCCUR = new
	// SetExpansionStrategy("UNARY_KBT_AND_COOCCUR",
	// UnaryKBTAndLabel_CoOccurenceStrategy.class);
	//
	// public static SetExpansionStrategy UNARY_KBT_AND_COOCCUR_ATTRIBUTE_KBT =
	// new SetExpansionStrategy("UNARY_KBT_AND_COOCCUR_ATTRIBUTE_KBT",
	// UnaryKBTAndLabel_CoOccurence_Attribute_KBT.class);
	//
	//
	//
	// public static SetExpansionStrategy TABLE_OVERLAP_LABEL = new
	// SetExpansionStrategy("TABLE_OVERLAP_LABEL",
	// TableOverlapLabelStrategy.class);
	//
	//
	// public static SetExpansionStrategy TABLE_OVERLAP_INSTANCE = new
	// SetExpansionStrategy("TABLE_OVERLAP_INSTANCE",
	// TableOverlapInstanceStrategy.class);
	//
	//
	// public static SetExpansionStrategy TABLE_JACCARD_LABEL = new
	// SetExpansionStrategy("TABLE_JACCARD_LABEL",
	// TableJaccardLabelStrategy.class);
	//
	//
	// public static SetExpansionStrategy TABLE_JACCARD_INSTANCE = new
	// SetExpansionStrategy("TABLE_JACCARD_INSTANCE",
	// TableJaccardInstanceStrategy.class);
	//
	// public static SetExpansionStrategy TABLE_JACCARD_INSTANCE_NORMALIZED =
	// new SetExpansionStrategy("TABLE_JACCARD_INSTANCE_NORMALIZED",
	// TableJaccardInstanceNormalizedStrategy.class);
	//
	// public static SetExpansionStrategy
	// TFIDF_TABLE_JACCARD_INSTANCE_NORMALIZED = new
	// SetExpansionStrategy("TFIDF_TABLE_JACCARD_INSTANCE_NORMALIZED",
	// TFIDF_TableJaccardInstanceNormalizedStrategy.class);
	//
	//
	//
	// public static SetExpansionStrategy TFIDF_ATTRIBUTE_DIRECT = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT",
	// TFIDF_Attribute_Direct_ClassBlocked.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_PHI = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_PHI",
	// AssociationLabelPhi.class);
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_PMI = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_PMI",
	// AssociationLabelPMI.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_TFIDF = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_TFIDF",
	// AssociationLabelTFIDF.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_COMBINED = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_COMBINED",
	// AssociationLabelCombined.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_PHI_DEVIATION = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_PHI_DEVIATION",
	// AssociationLabelPhiDev.class);
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_PMI_DEVIATION = new
	// SetExpansionStrategy("ASSOCIATION_LABEL_PMI_DEVIATION",
	// AssociationLabelPMIDev.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_TFIDF_DEVIATION =
	// new SetExpansionStrategy("ASSOCIATION_LABEL_TFIDF_DEVIATION",
	// AssociationLabelTFIDFDev.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_LABEL_COMBINED_DEVIATION =
	// new SetExpansionStrategy("ASSOCIATION_LABEL_COMBINED_DEVIATION",
	// AssociationLabelCombinedDev.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_INSTANCE_PHI = new
	// SetExpansionStrategy("ASSOCIATION_INSTANCE_PHI",
	// AssociationInstancePhi.class);
	//
	// public static SetExpansionStrategy ASSOCIATION_INSTANCE_PMI = new
	// SetExpansionStrategy("ASSOCIATION_INSTANCE_PMI",
	// AssociationInstancePMI.class);
	//
	//
	// public static SetExpansionStrategy ASSOCIATION_INSTANCE_TFIDF = new
	// SetExpansionStrategy("ASSOCIATION_INSTANCE_TFIDF",
	// AssociationInstanceTFIDF.class);
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_AVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_AVERAGE",
	// AttributeDirectAndOverlapInstanceAverageStrategy.class);
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_DIRECT_AND_JACCARD_INSTANCE_MIN = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_AND_JACCARD_INSTANCE_MIN",
	// AttributeDirectAndJaccardInstanceMinStrategy.class);
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MAX = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MAX",
	// AttributeDirectAndOverlapInstanceMaxStrategy.class);
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MIN = new
	// SetExpansionStrategy("ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MIN",
	// AttributeDirectAndOverlapInstanceMinStrategy.class);
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_AVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_AVERAGE",
	// AttributeKBTAndJaccardInstanceAverageStrategy.class);
	//
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MAX
	// = new SetExpansionStrategy("ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MAX",
	// AttributeKBTAndJaccardInstanceMaxStrategy.class);
	//
	// public static SetExpansionStrategy ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MIN
	// = new SetExpansionStrategy("ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MIN",
	// AttributeKBTAndJaccardInstanceMinStrategy.class);
	//
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_ABSMAX = new
	// SetExpansionStrategy("ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_ABSMAX",
	// AttributeKBTAndJaccardInstanceAbsMaxStrategy.class);
	//
	// public static SetExpansionStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_WEIGHTEDAVERAGE = new
	// SetExpansionStrategy("ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_WEIGHTEDAVERAGE",
	// AttributeKBTAndJaccardInstanceWeightedAverageStrategy.class);
	//
	//
	// public static SetExpansionStrategy LABEL_SIMILARITY = new
	// SetExpansionStrategy("LABEL_SIMILARITY",
	// LabelSimilarityClusterer.class);
	//
	// public static SetExpansionStrategy LABEL_SIMILARITY_NORMALIZED = new
	// SetExpansionStrategy("LABEL_SIMILARITY_NORMALIZED",
	// LabelSimilarityNormalizedClusterer.class);
	//
	//
	//
	// public static SetExpansionStrategy
	// LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_CLASS_BLOCKING = new
	// SetExpansionStrategy("LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_CLASS_BLOCKING",
	// AttributeDirectAndJaccardInstanceWeightedAverageClassBlocking.class);
	//
	//
	// public static SetExpansionStrategy
	// LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_LABEL_BLOCKING = new
	// SetExpansionStrategy("LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_LABEL_BLOCKING",
	// AttributeDirectAndJaccardInstanceWeightedAverageLabelBlocking.class);
	//
	//
	//
	// public static SetExpansionStrategy TF_IDF_BLOCKING_STRATEGY = new
	// SetExpansionStrategy("TF_IDF_BLOCKING_STRATEGY",
	// TfIDFClustererClassBlocked.class);
	
	
	public static SetExpansionStrategy FULL_LABEL_SIMILARITY = new SetExpansionStrategy("FULL_LABEL_SIMILARITY",
			LabelSimilarityFullCluster.class);
	
	// public static SetExpansionStrategy
	// FULL_LABEL_SIMILARITY_WITH_SURFACE_FORMS = new
	// SetExpansionStrategy("FULL_LABEL_SIMILARITY_WITH_SURFACE_FORMS",
	// LabelSimilarityFullCluster_WithSurfaceForms.class);
	//
	// public static SetExpansionStrategy
	// FULL_LABEL_SIMILARITY_WITH_SURFACE_FORMS_AND_STOP_WORDS = new
	// SetExpansionStrategy("FULL_LABEL_SIMILARITY_WITH_SURFACE_FORMS_AND_STOP_WORDS",
	// LabelSimilarityFullCluster_WithStopWords.class);
	//
	//
	//
	//
	// public static SetExpansionStrategy FULL_LABEL_COSINE_WITH_NEGATIVE = new
	// SetExpansionStrategy("FULL_LABEL_COSINE_WITH_NEGATIVE",
	// LabelSimilarityFullCluster_COSINE_WITH_NEGATIVE.class);
	//
	// public static SetExpansionStrategy FULL_LABEL_COSINE_WITH_TF_IDF = new
	// SetExpansionStrategy("FULL_LABEL_TF_IDF",
	// LabelSimilarityFullCluster_With_TF_IDF.class);
	//
	//
	// public static SetExpansionStrategy
	// FULL_LABEL_ATTRIBUTE_KBT_JACCARD_LABEL_NORMALIZED = new
	// SetExpansionStrategy("FULL_LABEL_ATTRIBUTE_KBT_JACCARD_LABEL_NORMALIZED",
	// LabelAttributeKBTAndJaccardStringFullAverage.class);
	
	
	
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT = new
	// SetExpansionStrategy("ATT_DIRECT", New_Attribute_DIRECT.class);
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT_WITH_SF = new
	// SetExpansionStrategy("NEW_ATTRIBUTE_DIRECT_WITH_SF",
	// New_Attribute_DIRECT_with_Surface.class);
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT_WITH_NR = new
	// SetExpansionStrategy("NEW_ATTRIBUTE_DIRECT_WITH_NR",
	// New_Attribute_DIRECT_with_NumericRange.class);
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT_FULL = new
	// SetExpansionStrategy("NEW_ATTRIBUTE_DIRECT_FULL",
	// New_Attribute_DIRECT_FULL.class);
	//
	// public static SetExpansionStrategy
	// NEW_ATTRIBUTE_DIRECT_FULL_INDIVIDUAL_OPTIMIZED = new
	// SetExpansionStrategy(
	// "NEW_ATTRIBUTE_DIRECT_FULL_INDIVIDUAL_OPTIMIZED",
	// New_Attribute_DIRECT_FULL_INDIVIDUAL_OPTIMIZED.class);
	//
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT_FULL_CORRELATION
	// = new SetExpansionStrategy("NEW_ATTRIBUTE_DIRECT_FULL_CORRELATION",
	// New_Attribute_DIRECT_FULL_Correlation.class);
	//
	// public static SetExpansionStrategy NEW_ATTRIBUTE_DIRECT_FULL_DEVIATION =
	// new SetExpansionStrategy("NEW_ATTRIBUTE_DIRECT_FULL_DEVIATION",
	// New_Attribute_DIRECT_FULL_Deviation.class);
	
	
	

	// @SuppressWarnings("unchecked")
	// public static SetExpansionStrategy ALL_WTIH_IMPLICIT = new
	// SetExpansionStrategy("ALL_WITH_IMPLICIT",
	// ALL_WTIH_IMPLICIT.class);
	//
	// @SuppressWarnings("unchecked")
	// public static SetExpansionStrategy NEW_COMBINED = new
	// SetExpansionStrategy("NEW_COMBINED",
	// Combined.class
	// , Lists.newArrayList(Sets.newHashSet("LABEL",
	// "BOW", "BOW_TABLE"), Sets.newHashSet("LABEL",
	// "ATTRIBUTE"), Sets.newHashSet("LABEL",
	// "AA")));
	//
	public static SetExpansionStrategy COMBINED_BASE = new SetExpansionStrategy("COMBINED_BASE", Combined_BASE.class);



	// RF_BASE

	// public static SetExpansionStrategy COMBINED_RF_BASE_Label_SameTable_Bow =
	// new SetExpansionStrategy("COMBINED_RF_BASE_Label_SameTable_Bow",
	// Combined_RF_BASE_Label_SameTable_Bow.class);
	//
	// public static SetExpansionStrategy
	// COMBINED_RF_BASE_Label_SameTable_Bow_Phi = new
	// SetExpansionStrategy("COMBINED_RF_BASE_Label_SameTable_Bow_Phi",
	// Combined_RF_BASE_Label_SameTable_Bow_Phi.class);
	//
	// public static SetExpansionStrategy
	// COMBINED_RF_BASE_Label_SameTable_Bow_Phi_Attribute = new
	// SetExpansionStrategy(
	// "COMBINED_RF_BASE_Label_SameTable_Bow_Phi_Attribute",
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute.class);
	//
	// public static SetExpansionStrategy
	// COMBINED_RF_BASE_Label_SameTable_Bow_Phi_Attribute_Implicit = new
	// SetExpansionStrategy(
	// "COMBINED_RF_BASE_Label_SameTable_Bow_Phi_Attribute_Implicit",
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute_Implicit.class);

	public static SetExpansionStrategy COMBINED_RF_BASE = new SetExpansionStrategy("COMBINED_RF_BASE", Combined_RF_BASE.class);


	// RF_NEW

	public static SetExpansionStrategy RF_LABEL = new SetExpansionStrategy("RF_LABEL", CLUSTERING_SIMS_LIST.LABEL,
			CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);



	// public static SetExpansionStrategy RF_LABEL_LABELSF_LABELOVERLAP = new
	// SetExpansionStrategy(
	// "RF_Z_LABEL_LABELSF_LABELOVERLAP",
	// CLUSTERING_SIMS_LIST.LABEL_LABELOVERLAP_LABELSF,
	// CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);
	public static SetExpansionStrategy RF_LABEL_BOW = new SetExpansionStrategy("RF_LABEL_BOW",
			CLUSTERING_SIMS_LIST.LABEL_BOW, CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);
	public static SetExpansionStrategy RF_LABEL_BOW_PHI = new SetExpansionStrategy("RF_LABEL_BOW_PHI",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI,
			CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);

	public static SetExpansionStrategy RF_LABEL_BOW_PHI_ATTRIBUTE = new SetExpansionStrategy("RF_LABEL_BOW_PHI_ATTRIBUTE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE, CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);

	public static SetExpansionStrategy RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT = new SetExpansionStrategy("RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT,
			CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);

	public static SetExpansionStrategy RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE = new SetExpansionStrategy("RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE,
			CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);

	public static SetExpansionStrategy RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP = new SetExpansionStrategy(
			"RF_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP", CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP,
			CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE);

	// WA

	public static SetExpansionStrategy WA_LABEL = new SetExpansionStrategy("WA_LABEL", CLUSTERING_SIMS_LIST.LABEL,
			CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);



	// public static SetExpansionStrategy WA_LABEL_LABELSF_LABELOVERLAP = new
	// SetExpansionStrategy(
	// "WA_Z_LABEL_LABELSF_LABELOVERLAP",
	// CLUSTERING_SIMS_LIST.LABEL_LABELOVERLAP_LABELSF,
	// CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);
	public static SetExpansionStrategy WA_LABEL_BOW = new SetExpansionStrategy("WA_LABEL_BOW",
			CLUSTERING_SIMS_LIST.LABEL_BOW, CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);
	public static SetExpansionStrategy WA_LABEL_BOW_PHI = new SetExpansionStrategy("WA_LABEL_BOW_PHI",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI,
			CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);

	public static SetExpansionStrategy WA_LABEL_BOW_PHI_ATTRIBUTE = new SetExpansionStrategy("WA_LABEL_BOW_PHI_ATTRIBUTE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE, CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);

	public static SetExpansionStrategy WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT = new SetExpansionStrategy("WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT,
			CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);

	public static SetExpansionStrategy WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE = new SetExpansionStrategy("WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE,
			CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);

	public static SetExpansionStrategy WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP = new SetExpansionStrategy(
			"WA_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP", CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP,
			CLUSTERING_SIMS_AGGREGATOR.WEIGHTED_AVERAGE);

	// ET

	public static SetExpansionStrategy ET_LABEL = new SetExpansionStrategy("ET_LABEL", CLUSTERING_SIMS_LIST.LABEL,
			CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);



	public static SetExpansionStrategy ET_LABEL_BOW = new SetExpansionStrategy("ET_LABEL_BOW",
			CLUSTERING_SIMS_LIST.LABEL_BOW, CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);
	public static SetExpansionStrategy ET_LABEL_BOW_PHI = new SetExpansionStrategy("ET_LABEL_BOW_PHI",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI,
			CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);

	public static SetExpansionStrategy ET_LABEL_BOW_PHI_ATTRIBUTE = new SetExpansionStrategy("ET_LABEL_BOW_PHI_ATTRIBUTE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE, CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);

	public static SetExpansionStrategy ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT = new SetExpansionStrategy("ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT,
			CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);

	public static SetExpansionStrategy ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE = new SetExpansionStrategy("ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE",
			CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE,
			CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);

	public static SetExpansionStrategy ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP = new SetExpansionStrategy(
			"ET_LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP", CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP,
			CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE);

	// DONE DONE

	// public static SetExpansionStrategy COMBINED_RF_BASE_Label_SameTable = new
	// SetExpansionStrategy("COMBINED_RF_BASE_Label_SameTable",
	// Combined_RF_BASE_Label_SameTable.class);
	//
	// public static SetExpansionStrategy COMBINED_RFDES_BASE = new
	// SetExpansionStrategy("COMBINED_RFDES_BASE", Combined_RF_Desc_BASE.class);
	//
	// public static SetExpansionStrategy COMBINED_RandomForest_BackFitting =
	// new SetExpansionStrategy("COMBINED_RandomForest_BackFitting",
	// Combined_RandomForest_BackFitting.class);
	// public static SetExpansionStrategy COMBINED_RandomTree = new
	// SetExpansionStrategy("COMBINED_RandomTree", Combined_RandomTree.class);
	// public static SetExpansionStrategy COMBINED_RandomTree_BackFitting = new
	// SetExpansionStrategy("COMBINED_RandomTree_BackFitting",
	// Combined_RandomTree_BackFitting.class);
	//
	public static SetExpansionStrategy Container_Clusterer = new SetExpansionStrategy("Container_Clusterer", Container_Clusterer.class);
	//
	// public static SetExpansionStrategy COMBINED_J48 = new
	// SetExpansionStrategy("COMBINED_J48", Combined_J48.class);
	//
	// public static SetExpansionStrategy COMBINED_M5P = new
	// SetExpansionStrategy("COMBINED_M5P", Combined_M5P.class);
	//
	// public static SetExpansionStrategy COMBINED_RF_BOW_NO_LABEL = new
	// SetExpansionStrategy("COMBINED_RF_NO_LABEL_BOW",
	// Combined_RF_NO_LABEL.class);
	//
	// public static SetExpansionStrategy
	// COMBINED_RF_BOW_NO_LABEL_SAME_TABLE_SIM = new
	// SetExpansionStrategy("COMBINED_RF_NO_LABEL_BOW_TABLE_SIM",
	// Combined_RF_NO_LABEL_SAME_TABLE_SIM.class);
	//
	// public static SetExpansionStrategy COMBINED_REPTree = new
	// SetExpansionStrategy("COMBINED_REPTree", Combined_REPTree.class);
	// public static SetExpansionStrategy COMBINED_LinearRegression = new
	// SetExpansionStrategy("COMBINED_LinearRegression",
	// Combined_LinearRegression.class);
	// public static SetExpansionStrategy COMBINED_LogisticRegression = new
	// SetExpansionStrategy("COMBINED_LogisticRegression",
	// Combined_LogisticRegression.class);
	//
	// public static SetExpansionStrategy COMBINED_SimpleCART = new
	// SetExpansionStrategy("COMBINED_SimpleCART", Combined_SimpleCART.class);
	//
	// public static SetExpansionStrategy COMBINED_RandomForest = new
	// SetExpansionStrategy("COMBINED_RandomForest",
	// Combined_RandomForest.class);

	public static SetExpansionStrategy COMBINED_RandomForest_NEW = new SetExpansionStrategy("COMBINED_RandomForest_NEW", Combined_RandomForest_New.class);

	// public static SetExpansionStrategy COMBINED_RandomForest_NEW_NN = new
	// SetExpansionStrategy("COMBINED_RandomForest_NEW_NN",
	// Combined_RandomForest_New_NN.class);
	//
	// public static SetExpansionStrategy COMBINED_Logistic_NEW = new
	// SetExpansionStrategy("COMBINED_Logistic_NEW",
	// Combined_Logistics_New.class);
	//
	// public static SetExpansionStrategy COMBINED_Logistic_NEW_ET = new
	// SetExpansionStrategy("COMBINED_Logistic_NEW_ET",
	// Combined_Logistics_New_ET.class);
	//
	public static SetExpansionStrategy COMBINED_RandomForest_ET = new SetExpansionStrategy("COMBINED_RandomForest_ET", Combined_RandomForest_ET.class);

	public static SetExpansionStrategy COMBINED_RandomForest_ET_with_Backfitting = new SetExpansionStrategy("COMBINED_RandomForest_ET_with_Backfitting",
			Combined_RandomForest_ET_with_Backfitting.class);
	//
	// public static SetExpansionStrategy COMBINED_RandomForest_OPTIMIZED = new
	// SetExpansionStrategy("COMBINED_RandomForest_OPTIMIZED",
	// Combined_RandomForest_Optimized.class);
	//
	// public static SetExpansionStrategy COMBINED_RandomForest_Classifier = new
	// SetExpansionStrategy("COMBINED_RandomForest_Classifier",
	// Combined_RandomForest_Classifier.class);
	//
	// public static SetExpansionStrategy COMBINED_RandomForest_Classifier_MT =
	// new SetExpansionStrategy("COMBINED_RandomForest_Classifier_MT",
	// Combined_RandomForest_Classifier_MultiTree.class);
	//
	// public static SetExpansionStrategy
	// Combined_RandomForest_Classifier_MultiTree_New_BOW = new
	// SetExpansionStrategy(
	// "Combined_RandomForest_Classifier_MultiTree_New_BOW",
	// expansion.set.strategies.trees.Combined_RandomForest_Classifier_MultiTree_New_BOW.class);
	//
	//
	// public static SetExpansionStrategy
	// COMBINED_RandomForest_Classifier_MT_NEW_BOW_TBLE_SIM = new
	// SetExpansionStrategy(
	// "COMBINED_RandomForest_Classifier_MT_NEW_BOW_TBLE_SIM",
	// expansion.set.strategies.trees.Combined_RandomForest_Classifier_MultiTree_New_BOW_TABLESIM.class);
	//
	// public static SetExpansionStrategy COMBINED_LMT = new
	// SetExpansionStrategy("COMBINED_LMT", Combined_LMT.class);
	//
	// public static SetExpansionStrategy COMBINED_LMT_MT = new
	// SetExpansionStrategy("COMBINED_LMT_MT", Combined_LMT_MT.class);
	//
	// public static SetExpansionStrategy COMBINED_LMT_Options = new
	// SetExpansionStrategy("COMBINED_LMT_Options", Combined_LMT_Options.class);
	//
	// public static SetExpansionStrategy ALL_NO_AA = new
	// SetExpansionStrategy("ALL_NO_AA", Combined_without_AA.class);
	//
	// public static SetExpansionStrategy NEW_COMBINED_PREDICTION = new
	// SetExpansionStrategy("NEW_COMBINED_PREDICTION",
	// Combined_Prediction.class);
	//
	//
	// public static SetExpansionStrategy NEW_COMBINED_DEVIATION = new
	// SetExpansionStrategy("NEW_COMBINED_DEVIATION", Combined_Deviation.class);
	//
	//
	//
	// public static SetExpansionStrategy NEW_ATTRIBUTE_KBT_SCORED = new
	// SetExpansionStrategy("ATT_KBT_SCORED", New_Attribute_KBT_SCORED.class);
	// public static SetExpansionStrategy
	// NEW_ATTRIBUTE_KBT_THRESHOLDED_AND_SCORED = new
	// SetExpansionStrategy("ATT_KBT_THRESHOLDED_AND_SCORED",
	// New_Attribute_KBT_THRESHOLDED_AND_SCORED.class);
	// public static SetExpansionStrategy NEW_ATTRIBUTE_KBT_THRESHOLDED = new
	// SetExpansionStrategy("ATT_KBT_THRESHOLDED",
	// New_Attribute_KBT_THRESHOLDED.class);
	// public static SetExpansionStrategy NEW_ATTRIBUTE_KBT_POSITIVE_SCORED =
	// new SetExpansionStrategy("ATT_KBT_POSITIVE_SCORED",
	// New_Attribute_KBT_POSITIVE_SCORED.class);

}
