package expansion.set.strategies.rowclusterers;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import expansion.set.clustering.RowClusterer;
import expansion.set.strategies.LabelSimilarityFullCluster;
import expansion.set.strategies.SetExpansionStrategy;
import expansion.set.strategies.combined.Combined_RF_BASE;
import expansion.set.strategies.ea.Container_Clusterer;
import expansion.set.strategies.evaluatemethod.CLUSTERING_METHOD_CREATOR;
import expansion.set.strategies.evaluatemethod.CLUSTERING_STRATEGY_DEFINITION_WORKAROUND;
import expansion.set.strategies.trees.Combined_RandomForest_New;
public class RowClustererRepository {
	
	// @Inject
	// InstanceBasedClusterer INSTANCE_BASED_CLUSTERER;
	//
	// @Inject
	// LabelSimilarityClustererClassBlocked labelSimilarityRowClustererBlocked;
	//
	// @Inject
	// LabelSimilarityClustererClassUnblocked
	// labelSimilarityRowClustererUnblocked;
	//
	// @Inject
	// CoOccurence_DEFAULT_ClassBlocked coOccurenceDefault;
	//
	// @Inject
	// CoOccurence_Instance_DEFAULT_ClassBlocked coOccurenceInstanceDefault;
	//
	// // @Inject
	// // CoOccurence_MaxSim_ClassBlocked coOccurrence_MaxSim_blocked;
	// //
	// // @Inject
	// // CoOccurence_PMI_ClassBlocked coOccurrence_PMI_blocked;
	// //
	// // @Inject
	// // CoOccurence_NPMI_ClassBlocked coOccurrence_NPMI_blocked;
	//
	// @Inject
	// Attribute_Direct_ClassBlocked attributeDirect;
	//
	// @Inject
	// Attribute_KBT_ClassBlocked attributeKbt;
	//
	// @Inject
	// AttributeKBT_CoOccurence_INSTANCE_DEFAULT_BLOCKED kbt_PMI_blocked;
	//
	// @Inject
	// AttributeDirect_CoOccurence_DEFAULT_BLOCKED kbt_Direct_coOccurence;
	//
	// @Inject
	// UnaryKBTAndLabelStrategy kbtUnaryAndLabel;
	//
	// @Inject
	// UnaryKBTStrategy kbtUnary;
	//
	// @Inject
	// UnaryDirectAndLabelStrategy unaryDirectAndLabel;
	//
	// @Inject
	// UnaryDirectStrategy unaryDirect;
	//
	//
	//
	// @Inject
	// UnaryKBTAndLabel_Attribute_KBT unaryKbtAndLabel_attribute_KBT;
	//
	// @Inject
	// UnaryKBTAndLabel_CoOccurenceStrategy unaryKbtAndLabel_cooccur;
	//
	// @Inject
	// UnaryKBTAndLabel_CoOccurence_Attribute_KBT
	// unaryKbtAndLabel_cooccur_attribute_KBT;
	//
	//
	// @Inject
	// TableOverlapLabelStrategy TABLE_OVERLAP_LABEL;
	//
	//
	// @Inject
	// TableOverlapInstanceStrategy TABLE_OVERLAP_INSTANCE ;
	//
	//
	// @Inject
	// TableJaccardLabelStrategy TABLE_JACCARD_LABEL;
	//
	//
	// @Inject
	// TableJaccardInstanceStrategy TABLE_JACCARD_INSTANCE ;
	//
	//
	// @Inject
	// TableJaccardInstanceNormalizedStrategy TABLE_JACCARD_INSTANCE_NORMALIZED
	// ;
	//
	// @Inject
	// AssociationLabelPhi ASSOCIATION_LABEL_PHI ;
	//
	// @Inject
	// AssociationLabelPMI ASSOCIATION_LABEL_PMI;
	//
	//
	// @Inject
	// AssociationLabelTFIDF ASSOCIATION_LABEL_TFIDF;
	//
	//
	//
	// @Inject
	// AssociationLabelPhiDev ASSOCIATION_LABEL_PHIDev ;
	//
	// @Inject
	// AssociationLabelPMIDev ASSOCIATION_LABEL_PMIDev;
	//
	//
	// @Inject
	// AssociationLabelTFIDFDev ASSOCIATION_LABEL_TFIDFDev;
	//
	//
	// @Inject
	// AssociationInstancePhi ASSOCIATION_INSTANCE_PHI;
	//
	// @Inject
	// AssociationInstancePMI ASSOCIATION_INSTANCE_PMI;
	//
	// @Inject
	// AssociationInstanceTFIDF ASSOCIATION_INSTANCE_TFIDF;
	//
	// @Inject
	// AttributeDirectAndOverlapInstanceAverageStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_AVERAGE;
	//
	// @Inject
	// AttributeDirectAndJaccardInstanceMinStrategy
	// ATTRIBUTE_DIRECT_AND_JACCARD_INSTANCE_AVERAGE;
	//
	// @Inject
	// AttributeDirectAndOverlapInstanceMaxStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MAX;
	//
	// @Inject
	// AttributeDirectAndOverlapInstanceMinStrategy
	// ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MIN;
	//
	//
	// @Inject
	// AttributeKBTAndJaccardInstanceAverageStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_AVERAGE;
	//
	// @Inject
	// AttributeKBTAndJaccardInstanceMaxStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MAX;
	//
	// @Inject
	// AttributeKBTAndJaccardInstanceMinStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MIN;
	//
	// @Inject
	// AttributeKBTAndJaccardInstanceAbsMaxStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_ABSMAX;
	//
	// @Inject
	// AttributeKBTAndJaccardInstanceWeightedAverageStrategy
	// ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_WEIGHTEDAVERAGE;
	//
	//
	// @Inject
	// LabelSimilarityClusterer LABEL_SIMILARITY;
	//
	// @Inject
	// LabelSimilarityNormalizedClusterer LABEL_SIMILARITY_NORMALIZED;
	//
	//
	//
	//
	//
	// @Inject
	//
	// Attribute_Direct_ClassBlocked_WeightedAverage
	// ATTRIBUTE_DIRECT_LABEL_WEIGHTED_AVERAGE;
	//
	//
	// @Inject
	// Attribute_Direct_ClassBlocked_Average ATTRIBUTE_DIRECT_LABEL_AVERAGE;
	//
	// @Inject
	// Attribute_Direct_ClassBlocked_AbsMax ATTRIBUTE_DIRECT_LABEL_ABSMAX;
	//
	//
	// @Inject
	//
	// Attribute_KBT_ClassBlocked_WeightedAverage
	// ATTRIBUTE_KBT_LABEL_WEIGHTED_AVERAGE;
	//
	//
	// @Inject
	// Attribute_KBT_ClassBlocked_Average ATTRIBUTE_KBT_LABEL_AVERAGE;
	//
	// @Inject
	// Attribute_KBT_ClassBlocked_AbsMax ATTRIBUTE_KBT_LABEL_ABSMAX;
	//
	//
	// @Inject
	// TableJaccardInstanceNormalizedStrategy_WeightedAverage
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_WEIGHTED_AVERAGE;
	//
	//
	// @Inject
	// TableJaccardInstanceNormalizedStrategy_Average
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_AVERAGE;
	//
	// @Inject
	// TableJaccardInstanceNormalizedStrategy_AbsMax
	// TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_ABSMAX;
	//
	//
	// @Inject
	// AttributeDirectAndJaccardInstanceWeightedAverageClassBlocking
	// LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_CLASS_BLOCKING;
	//
	// @Inject
	// AttributeDirectAndJaccardInstanceWeightedAverageLabelBlocking
	// LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_LABEL_BLOCKING;
	//
	// @Inject
	// TfIDFClustererClassBlocked TfIDFClustererClassBlocked;
	//
	//
	// @Inject
	// TFIDF_TableJaccardInstanceNormalizedStrategy
	// TFIDF_TABLE_JACCARD_INSTANCE_NORMALIZED;
	//
	//
	// @Inject
	// TFIDF_Attribute_Direct_ClassBlocked TFIDF_ATTRIBUTE_DIRECT;
	//
	//
	@Inject
	LabelSimilarityFullCluster FULL_LABEL_SIMILARITY;
	//
	//
	// @Inject
	// LabelAttributeKBTAndJaccardStringFullAverage
	// FULL_LABEL_ATTRIBUTE_KBT_JACCARD_LABEL_NORMALIZED;
	//
	//
	//
	// @Inject
	// New_Attribute_DIRECT New_Attribute_DIRECT;
	//
	// @Inject
	// New_Attribute_KBT_SCORED New_Attribute_KBT_SCORED;
	//
	// @Inject
	// New_Attribute_KBT_THRESHOLDED_AND_SCORED
	// New_Attribute_KBT_THRESHOLDED_AND_SCORED;
	//
	// @Inject
	// New_Attribute_KBT_THRESHOLDED New_Attribute_KBT_THRESHOLDED;
	//
	// @Inject
	// New_Attribute_KBT_POSITIVE_SCORED New_Attribute_KBT_POSITIVE_SCORED;
	//
	// @Inject
	// BagOfWords_Strategy bagOfWords_Strategy;
	//
	// @Inject
	// BagOfWords_Table_And_Label_Strategy bagOfWords_label_Strategy;
	//
	// @Inject
	// LabelSimilarityFullCluster_WithSurfaceForms
	// LabelSimilarityFullCluster_WithSurfaceForms;
	// @Inject
	// BagOfWords_Table_Strategy BagOfWords_Table_Strategy;
	//
	// @Inject
	// LabelSimilarityFullCluster_WithStopWords
	// LabelSimilarityFullCluster_WithSurfaceForms_and_StopWords;
	//
	// @Inject
	// LabelSimilarityFullCluster_COSINE_WITH_NEGATIVE
	// LabelSimilarityFullCluster_COSINE_WITH_NEGATIVE;
	//
	//
	// @Inject
	// LabelSimilarityFullCluster_With_TF_IDF
	// LabelSimilarityFullCluster_With_TF_IDF;
	//
	// @Inject
	// BagOfWords_And_Table_StopWords_Strategy
	// BagOfWords_And_Table_StopWords_Strategy;
	//
	//
	// @Inject
	// New_Attribute_DIRECT_with_Surface New_Attribute_DIRECT_with_Surface;
	//
	//
	// @Inject
	// New_Attribute_DIRECT_with_NumericRange
	// New_Attribute_DIRECT_with_NumericRange;
	//
	// @Inject
	// New_Attribute_DIRECT_FULL New_Attribute_DIRECT_FULL;
	//
	// @Inject
	// BagOfWords_Table_And_Label_Strategy_Covariance_Prediction
	// BagOfWords_Table_And_Label_Strategy_Covariance_Prediction;
	//
	//
	// @Inject
	// New_Attribute_DIRECT_FULL_Correlation
	// New_Attribute_DIRECT_FULL_Correlation;
	//
	//
	//
	// @Inject
	// Combined Combined;
	//
	// @Inject
	// Combined_Prediction Combined_Prediction;
	//
	// @Inject
	// AssociationLabelCombined AssociationLabelCombined;
	//
	//
	// @Inject
	// BagOfWords_And_Table_Deviation_Predicition
	// BagOfWords_And_Table_StopWords_Deviation_Predicition;
	//
	//
	// @Inject
	// BagOfWords_Table_And_Label_Strategy_Deviation_Prediction
	// BagOfWords_Table_And_Label_Strategy_Deviation_Prediction;
	//
	// @Inject
	// New_Attribute_DIRECT_FULL_Deviation New_Attribute_DIRECT_FULL_Deviation;
	//
	//
	// @Inject
	// AssociationLabelCombinedDev associationLabelCombinedDev;
	//
	//
	// @Inject
	// Combined_Deviation Combined_Deviation;
	//
	// @Inject
	// BagOfWords_Table_And_Label_Strategy_without_TF_IDF
	// BagOfWords_Table_And_Label_Strategy_without_TF_IDF;
	//
	// @Inject
	// New_Attribute_DIRECT_FULL_INDIVIDUAL_OPTIMIZED
	// New_Attribute_DIRECT_FULL_INDIVIDUAL_OPTIMIZED;
	//
	// @Inject
	// Combined_without_AA Combined_without_AA;
	//
	// @Inject
	// ALL_WTIH_IMPLICIT all_WTIH_IMPLICIT;



	@Inject
	Combined_RF_BASE combined_RF_BASE;


	@Inject
	Combined_RandomForest_New Combined_RandomForest_New;

	@Inject
	expansion.set.strategies.ea.Combined_RandomForest_ET Combined_RandomForest_ET;

	// @Inject
	// Combined_RF_BASE_Label_SameTable Combined_RF_BASE_Label_SameTable;
	// @Inject
	// Combined_RF_BASE_Label_SameTable_Bow
	// Combined_RF_BASE_Label_SameTable_Bow;
	// @Inject
	// Combined_RF_BASE_Label_SameTable_Bow_Phi
	// Combined_RF_BASE_Label_SameTable_Bow_Phi;
	// @Inject
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute;
	//
	// @Inject
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute_Implicit
	// Combined_RF_BASE_Label_SameTable_Bow_Phi_Attribute_Implicit;
	//
	// @Inject
	// Combined_Logistics_New Combined_Logistics_New;
	//
	// @Inject
	// Combined_Logistics_New_ET Combined_Logistics_New_ET;
	//
	// @Inject
	// Combined_RandomForest_New_NN Combined_RandomForest_New_NN;
	//
	// @Inject
	// Combined_RandomForest_ET_with_Backfitting
	// Combined_RandomForest_ET_with_Backfitting;

	@Inject
	Container_Clusterer Container_Clusterer;

	@Inject
	CLUSTERING_METHOD_CREATOR Clustering_Method_Creator;

	private volatile Map<Class<? extends RowClusterer>, RowClusterer> repository;


	public RowClustererRepository() {

	}

	@SuppressWarnings("unchecked")
	public synchronized void init() {
		if (repository == null) {
			
			this.repository = new HashMap<>();
		 
			try {
			for (Field field : this.getClass().getDeclaredFields()) {
			    field.setAccessible(true); // You might want to set modifier to public first.
			    Class<?> clazz = field.getType();
			  if( RowClusterer.class.isAssignableFrom(clazz)) {
				  RowClusterer value = (RowClusterer) field.get(this); 
				  this.repository.put((Class<? extends RowClusterer>) clazz, value);
				 
			  }
			   
			   
			   
			}
			}
			catch(  IllegalArgumentException | IllegalAccessException e) {
				throw new RuntimeException(e);
			}
			
			
//			this.repository.put(LabelSimilarityClustererClassBlocked.class, labelSimilarityRowClustererBlocked);
//			this.repository.put(LabelSimilarityClustererClassUnblocked.class, labelSimilarityRowClustererUnblocked);
//			// this.repository.put(CoOccurence_MaxSim_ClassBlocked.class,
//			// coOccurrence_MaxSim_blocked);
//			// this.repository.put(CoOccurence_PMI_ClassBlocked.class,
//			// coOccurrence_PMI_blocked);
//			// this.repository.put(CoOccurence_NPMI_ClassBlocked.class,
//			// coOccurrence_NPMI_blocked);
//
//			this.repository.put(CoOccurence_DEFAULT_ClassBlocked.class, coOccurenceDefault);
//
//			this.repository.put(CoOccurence_Instance_DEFAULT_ClassBlocked.class, coOccurenceInstanceDefault);
//
//			this.repository.put(Attribute_Direct_ClassBlocked.class, attributeDirect);
//			this.repository.put(Attribute_KBT_ClassBlocked.class, attributeKbt);
//			this.repository.put(AttributeKBT_CoOccurence_INSTANCE_DEFAULT_BLOCKED.class, kbt_PMI_blocked);
//			this.repository.put(AttributeDirect_CoOccurence_DEFAULT_BLOCKED.class, kbt_Direct_coOccurence);
//			this.repository.put(UnaryKBTAndLabelStrategy.class, kbtUnaryAndLabel);
//			this.repository.put(UnaryKBTStrategy.class, kbtUnary);
//			this.repository.put(UnaryDirectAndLabelStrategy.class, unaryDirectAndLabel);
//			this.repository.put(UnaryDirectStrategy.class, unaryDirect);
//
//			this.repository.put(UnaryKBTAndLabel_Attribute_KBT.class, unaryKbtAndLabel_attribute_KBT);
//			this.repository.put(UnaryKBTAndLabel_CoOccurenceStrategy.class, unaryKbtAndLabel_cooccur);
//			this.repository.put(UnaryKBTAndLabel_CoOccurence_Attribute_KBT.class, unaryKbtAndLabel_cooccur_attribute_KBT);
//			
//			
//			this.repository.put(TableOverlapLabelStrategy.class, TABLE_OVERLAP_LABEL);
//
//			this.repository.put(TableOverlapInstanceStrategy.class, TABLE_OVERLAP_INSTANCE);
//
//			this.repository.put(TableJaccardLabelStrategy.class, TABLE_JACCARD_LABEL);
//
//			this.repository.put(TableJaccardInstanceStrategy.class, TABLE_JACCARD_INSTANCE);
//
//
//			this.repository.put(TableJaccardInstanceNormalizedStrategy.class, TABLE_JACCARD_INSTANCE_NORMALIZED);
//			
//			this.repository.put(AssociationLabelPhi.class, ASSOCIATION_LABEL_PHI);
//
//			this.repository.put(AssociationLabelPMI.class, ASSOCIATION_LABEL_PMI);
//
//			this.repository.put(AssociationLabelTFIDF.class, ASSOCIATION_LABEL_TFIDF);
//
//			this.repository.put(AssociationInstancePhi.class, ASSOCIATION_INSTANCE_PHI);
//
//			this.repository.put(AssociationInstancePMI.class, ASSOCIATION_INSTANCE_PMI);
//
//			this.repository.put(AssociationInstanceTFIDF.class, ASSOCIATION_INSTANCE_TFIDF);
//
//			
//			this.repository.put(AttributeDirectAndOverlapInstanceAverageStrategy.class,  ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_AVERAGE);
//			
//			this.repository.put(AttributeDirectAndOverlapInstanceMaxStrategy.class,  ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MAX);
//			
//			this.repository.put(AttributeDirectAndOverlapInstanceMinStrategy.class,  ATTRIBUTE_DIRECT_AND_OVERLAP_INSTANCE_MIN);
//			
//			
//
//			this.repository.put(AttributeKBTAndJaccardInstanceAverageStrategy.class,   ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_AVERAGE);
//			
//			this.repository.put(AttributeKBTAndJaccardInstanceMaxStrategy.class,   ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MAX);
//			
//			this.repository.put(AttributeKBTAndJaccardInstanceMinStrategy.class,   ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_MIN);
//			
//			
//			
//			this.repository.put(AttributeKBTAndJaccardInstanceAbsMaxStrategy.class,    ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_ABSMAX);
//			
//			this.repository.put(AttributeKBTAndJaccardInstanceWeightedAverageStrategy.class,    ATTRIBUTE_KBT_AND_JACCARD_INSTANCE_WEIGHTEDAVERAGE);
//			
//			
//			
//			this.repository.put(LabelSimilarityClusterer.class,    LABEL_SIMILARITY);
//
//		 
//			this.repository.put(LabelSimilarityNormalizedClusterer.class,    LABEL_SIMILARITY_NORMALIZED);
//			
//			
//			
//
//			
//			this.repository.put(Attribute_Direct_ClassBlocked_WeightedAverage.class,    ATTRIBUTE_DIRECT_LABEL_WEIGHTED_AVERAGE);
//			this.repository.put(Attribute_Direct_ClassBlocked_AbsMax.class,    ATTRIBUTE_DIRECT_LABEL_ABSMAX);
//
//			this.repository.put(Attribute_Direct_ClassBlocked_Average.class,    ATTRIBUTE_DIRECT_LABEL_AVERAGE);
//			
//			this.repository.put(Attribute_KBT_ClassBlocked_WeightedAverage.class,    ATTRIBUTE_KBT_LABEL_WEIGHTED_AVERAGE);
//			this.repository.put(Attribute_KBT_ClassBlocked_AbsMax.class,    ATTRIBUTE_KBT_LABEL_ABSMAX);
//
//			this.repository.put(Attribute_KBT_ClassBlocked_Average.class,    ATTRIBUTE_KBT_LABEL_AVERAGE);
//
//			
//			this.repository.put(TableJaccardInstanceNormalizedStrategy_WeightedAverage.class,    TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_WEIGHTED_AVERAGE);
//			
//			
//			this.repository.put(TableJaccardInstanceNormalizedStrategy_Average.class,    TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_AVERAGE);
//			this.repository.put(TableJaccardInstanceNormalizedStrategy_AbsMax.class,    TABLE_JACCARD_INSTANCE_NORMALIZED_LABEL_ABSMAX);
//
//			
//			this.repository.put(InstanceBasedClusterer.class,  INSTANCE_BASED_CLUSTERER);
//			
//
//			this.repository.put(AttributeDirectAndJaccardInstanceMinStrategy.class,   ATTRIBUTE_DIRECT_AND_JACCARD_INSTANCE_AVERAGE);
//			
//			
//			
//			this.repository.put(
//			AttributeDirectAndJaccardInstanceWeightedAverageClassBlocking.class,    LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_CLASS_BLOCKING);
//			
//			this.repository.put(
//			AttributeDirectAndJaccardInstanceWeightedAverageLabelBlocking.class,     LABEL_ATTRIBUTE_DIRECT_AND_JACCARD_WEIGHTED_AVERAGE_LABEL_BLOCKING);
//			
//			
//			this.repository.put(TfIDFClustererClassBlocked.class, TfIDFClustererClassBlocked);
//			
//			this.repository.put(TFIDF_TableJaccardInstanceNormalizedStrategy.class,  TFIDF_TABLE_JACCARD_INSTANCE_NORMALIZED);
//			
//			
//			this.repository.put(TFIDF_Attribute_Direct_ClassBlocked.class, TFIDF_ATTRIBUTE_DIRECT);
//			
//			
//
//			this.repository.put(LabelSimilarityFullCluster.class, FULL_LABEL_SIMILARITY);
//			
//
//			this.repository.put(LabelAttributeKBTAndJaccardStringFullAverage.class,  FULL_LABEL_ATTRIBUTE_KBT_JACCARD_LABEL_NORMALIZED);
//			
//			
//			
//			this.repository.put(New_Attribute_DIRECT.class,   New_Attribute_DIRECT);
//			
//			this.repository.put(New_Attribute_KBT_SCORED.class,   New_Attribute_KBT_SCORED);
//			
//			this.repository.put(New_Attribute_KBT_THRESHOLDED_AND_SCORED.class,   New_Attribute_KBT_THRESHOLDED_AND_SCORED);
//			
//			this.repository.put( New_Attribute_KBT_THRESHOLDED.class,   New_Attribute_KBT_THRESHOLDED);
//			 
//			this.repository.put(New_Attribute_KBT_POSITIVE_SCORED.class,   New_Attribute_KBT_POSITIVE_SCORED);
		}
		

	}

	public RowClusterer get(Class<? extends RowClusterer> clazz) {
		if (repository == null)
			init();

		if (clazz == null) {
			throw new IllegalStateException("Asking for Clusterer of class null is not allowed!");
		} else {
			if (CLUSTERING_STRATEGY_DEFINITION_WORKAROUND.class.isAssignableFrom(clazz)) {
				CLUSTERING_STRATEGY_DEFINITION_WORKAROUND strategy;

					strategy = SetExpansionStrategy.strategyDefinitionWorkaroundMap.get(clazz);
					return Clustering_Method_Creator.getRowClusterer(strategy.getOptimizableClass(), strategy.getSimsList(), strategy.getAggregator());



			} else {
				RowClusterer clusterer = this.repository.get(clazz);
				if (clusterer == null) {
					throw new IllegalStateException("No Clusterer was registered for Class: " + clazz.getSimpleName());
				} else {
					return clusterer;
				}
			}
		}
	}


}
