package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import expansion.set.strategies.rowclusterers.unary.ClusterCombiner;

public class ClusterCombinerTest {

	public static void main(String[] args) {
		ClusterCombiner<String> cc = new ClusterCombiner<>();

		List<Set<String>> first = new ArrayList<>();
		first.add(new HashSet<>(Arrays.asList("A", "B", "C")));
		first.add(new HashSet<>(Arrays.asList("D", "F")));
		first.add(new HashSet<>(Arrays.asList("I", "J")));
		first.add(new HashSet<>(Arrays.asList("K", "L")));
		first.add(new HashSet<>(Arrays.asList("N", "O")));

		List<Set<String>> second = new ArrayList<>();
		second.add(new HashSet<>(Arrays.asList("A", "B", "C")));
		second.add(new HashSet<>(Arrays.asList("D", "F")));
		second.add(new HashSet<>(Arrays.asList("G", "H")));
		second.add(new HashSet<>(Arrays.asList("L", "M")));

		List<Set<String>> third = new ArrayList<>();
		third.add(new HashSet<>(Arrays.asList("D", "B", "C")));
		third.add(new HashSet<>(Arrays.asList("H", "I")));
		third.add(new HashSet<>(Arrays.asList("M", "N")));

		cc.add(first);
		cc.add(second);
		cc.add(third);

		System.out.println(cc.get().toString());

	}

}
