package expansion.set.strategies.rowclusterers;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeSet;

public class RangedMapTest {

	public static void main(String[] args) {
		
		Map<Integer, Double> map = new HashMap<>();
		map.put(1, 0.05);
		map.put(3, 0.1);
		map.put(5, 0.101);
		map.put(10, 0.111);
		map.put(22, 0.65);
		map.put(154, 0.7);
		map.put(1001, 0.8);
		map.put(1002, 0.9);
		
		RangedMap<Integer, Double> rm = new RangedMap<>(map);
		
		System.out.println("Greater than equal 0.1: " + new TreeSet<>(rm.greaterEqualThan(0.1)));
		System.out.println("Greater than 0.1: " + new TreeSet<>(rm.greaterThan(0.1)));
		
		System.out.println("Lower than equal 0.65: " + new TreeSet<>(rm.lowerEqualThan(0.65)));
		System.out.println("Lower than 0.65: " + new TreeSet<>(rm.lowerThan(0.65)));
		
		

		
		System.out.println("Greater than equal 0.11: " + new TreeSet<>(rm.greaterEqualThan(0.11)));
		System.out.println("Greater than 0.11: " + new TreeSet<>(rm.greaterThan(0.11)));
		
		System.out.println("Lower than equal 0.655: " + new TreeSet<>(rm.lowerEqualThan(0.655)));
		System.out.println("Lower than 0.655: " + new TreeSet<>(rm.lowerThan(0.655)));

	}

}
