package de.mannheim.uni.expansion.tablefusion.core.similarity.measures;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityMeasure;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class EmptySimilarity implements SimilarityMeasure {

	@Inject
	public EmptySimilarity() {

	}

	@Override
	public double get(AbstractObject a, AbstractObject b) {
		return 0.0;
	}

	@Override
	public double getQuickSimilarity(AbstractObject a, AbstractObject b) {
		return 0.0;
	}

	@Override
	public double getEquivalenceThreshold() {
		return 1.0;
	}

	@Override
	public boolean isEqual(AbstractObject a, AbstractObject b) {
		return false;
	}
}
