package de.mannheim.uni.expansion.tablefusion.modules;

import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;

@Module(library = true, complete = false)
public class OntologyReplacementModule {
	private OntologyRepository ontologyRepository;

	public OntologyReplacementModule() {
	}

	@Provides
	@Singleton
	OntologyRepository getOntologyRepository() {
		 return ontologyRepository;
	}

	public void setOntologyRepository(OntologyRepository ontologyRepository) {
		this.ontologyRepository = ontologyRepository;
	}

}
