package de.mannheim.uni.expansion.tablefusion.adapters.regressionweights;

import java.util.Collections;
import java.util.Map;

public class RegressionWeightsRepositoryImpl implements RegressionWeightsRepository {

	private final Map<String, RegressionWeights> map;

	// private final RegressionWeights averagedWeights;

	public RegressionWeightsRepositoryImpl(Map<String, RegressionWeights> map) {
		this.map = Collections.unmodifiableMap(map);
	}

	@Override
	public RegressionWeights getWeights(String prefix) {

		return map.get(prefix);
	}

	@Override
	public RegressionWeights getWeights(int learningSetNumber) {
		return map.get(String.valueOf(learningSetNumber));
	}

	@Override
	public RegressionWeights getWeights() {
		return getWeights("");
	}

	// private RegressionWeightsContainer
	// averageRegressionWeightsContainer(List<RegressionWeightsContainer>
	// containers) {
	//
	// Map<SimilarityType, RegressionWeightsScores> map = new
	// EnumMap<>(SimilarityType.class);
	//
	// for (SimilarityType type : SimilarityType.values()) {
	//
	// for (RegressionWeightsContainer container : containers) {
	//
	// List<RegressionWeightsScores> scoresList = new ArrayList<>();
	// }
	//
	// }
	//
	// }
	//
	// private RegressionWeightsScores
	// averageWeights(List<RegressionWeightsScores> scores) {
	//
	// }

}
