package de.mannheim.uni.expansion.tablefusion.analysis.stores;

public class FusedResultsSingle {
	private int wrongTriples;
	private int correctTriples;
	private int newTriples;

	public FusedResultsSingle() {
		super();
		this.wrongTriples = 0;
		this.correctTriples = 0;
	}

	// public FusedResultsSingle(int correctTriples, int wrongTriples, int
	// finalized) {
	// super();
	// this.correctTriples = correctTriples;
	// this.wrongTriples = wrongTriples;
	// }

	//
	// public void finalize() {
	// this.finalized = true;
	// }

	public Double getAccuracy() {
		return ((double) correctTriples) / ((double) (correctTriples + wrongTriples));
	}

	public synchronized void incWrong() {
		wrongTriples++;
	}

	public synchronized void incCorrect() {
		correctTriples++;
	}

	public synchronized void incNew() {
		newTriples++;
	}

	public int getWrongTriples() {
		return wrongTriples;
	}

	public int getCorrectTriples() {
		return correctTriples;
	}

	public int getOverlappingTriples() {
		return wrongTriples + correctTriples;
	}

	public int getNewTriples() {
		return newTriples;
	}

	@Override
	public String toString() {
		return "FusedResultsSingle [wrongTriples=" + wrongTriples + ", correctTriples=" + correctTriples + ", newTriples=" + newTriples + "]";
	}

}