package de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic;

import java.util.function.Function;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.tablefusion.core.fusing.BaseFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ClusterFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.Fuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.FusionScoreThresholdAdapter;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;
import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityCalculator;
import de.mannheim.uni.expansion.utils.OtsuThresholder;
import de.uni_mannheim.dws.expansion.data.ontology.model.fusedvalue.FusedValue;

public class AbstractNormalFuser implements Fuser {
	private final SimilarityCalculator sc;
	private final OtsuThresholder otsuThresholder;
	private final ClusterFuser clusterFuser;
	private final BaseFuser baseFuser;

	public AbstractNormalFuser(SimilarityCalculator sc, OtsuThresholder otsuThresholder, ClusterFuser clusterFuser, BaseFuser baseFuser) {
		this.sc = sc;
		this.otsuThresholder = otsuThresholder;
		this.clusterFuser = clusterFuser;
		this.baseFuser = baseFuser;
	}

	// @Override
	// public FusedValue fuse(MatchedValues values, TableScores probabilities,
	// double threshold) {
	//
	// List<AbstractObject> objectValues = new ArrayList<AbstractObject>();
	// for (SingleValue e : values.getValues()) {
	//
	// AbstractObject o = e.getValue();
	//
	// objectValues.add(o);
	//
	// }
	//
	// return baseFuser.simpleFuse(objectValues);
	//
	// }
	//
	// @Override
	// public FusedValue fuseList(MatchedValues values, TableScores
	// probabilities, double threshold) {
	//
	// SimilarityMeasure sm = sc.getMeasure(values.getDataType());
	//
	// List<ClusterValue> clusterValues = new ArrayList<>();
	//
	// for (SingleValue e : values.getValues()) {
	//
	// AbstractObject o = e.getValue();
	// // if (o instanceof List) {
	// //
	// // for (Object o2 : ((List<?>) o)) {
	// // clusterValues.add(new ClusterValue(o2, 1.0));
	// // }
	// //
	// // } else {
	//
	// clusterValues.add(new ClusterValue(o, 1.0));
	// // }
	//
	// }
	//
	// SortedSet<Cluster> clusters = clusterFuser.fuse(clusterValues, baseFuser,
	// sm);
	//
	// clusters = otsuThresholder.threshold(clusters);
	//
	// if (clusters.size() == 0)
	// return null;
	// else
	// return new FusedValue(clusters);
	// }

	@Override
	public FusedValue fuse(MatchedValues values, TableScores probabilities, double threshold, FusionScoreThresholdAdapter adapter, boolean onePerPLD,
			Function<AnnotatedTableId, String> pldGetter) {
		throw new IllegalStateException();
	}

	@Override
	public FusedValue fuseList(MatchedValues values, TableScores probabilities, double threshold) {
		throw new IllegalStateException();
	}

}
