package de.mannheim.uni.expansion.tablefusion.core.matching;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;

public interface MatchCreator {

	Map<TripleId, MatchedValues> matchColumns(AnnotatedTableId id, Set<ColumnIdx> columns);

	Map<TripleId, MatchedValues> matchColumns(AnnotatedTableId id, ColumnIdx columnIndex);
}
