package de.mannheim.uni.expansion.tablefusion.core.scoring.regression;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;

public class RegressionCluster {

	private final Object fusedValue;
	private final List<SingleValue> values;

	public RegressionCluster(List<SingleValue> values, Object fusedValue) {
		this.fusedValue = fusedValue;
		this.values = Collections.unmodifiableList(new ArrayList<>(values));
	}

	public Object getFusedValue() {
		return fusedValue;
	}

	public List<SingleValue> getValues() {
		return values;
	}

}
