package de.mannheim.uni.expansion.tablefusion.learning;

import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.utils.ImmuMaker;

public class RowValues {
	private final Map<TableRowId, Map<PropertyId, MatchedValues>> values;

	public RowValues(Map<TableRowId, Map<PropertyId, MatchedValues>> values) {
		super();
		this.values = ImmuMaker.mapWithMap(values);
	}

	public Map<TableRowId, Map<PropertyId, MatchedValues>> getValues() {
		return values;
	}

}
