package de.mannheim.uni.expansion.tablefusion.learning;

import java.io.Serializable;

import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;

public class SplitGroupedValuesSets implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final SplitGroupedValues fullSet;
	private final SplitGroupedValues learningSet;

	private final SplitGroupedValues testingSet;

	public SplitGroupedValuesSets(SplitGroupedValues fullSet, SplitGroupedValues learningSet, SplitGroupedValues testingSet) {
		this.fullSet = fullSet;
		this.learningSet = learningSet;
		this.testingSet = testingSet;
	}

	public SplitGroupedValues getLearningSet() {
		return learningSet;
	}

	public SplitGroupedValues getTestingSet() {
		return testingSet;
	}

	public SplitGroupedValues getFullSet() {
		return fullSet;
	}

}