package de.mannheim.uni.expansion.tablefusion.profiling.timestamps;

import de.mannheim.uni.expansion.tablefusion.analysis.writer.GenericAbstractResultsWriter;
import de.mannheim.uni.expansion.tablefusion.analysis.writer.ResultsCategory;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.AccumInteger;

public class TimeStampsOverlapWriter extends GenericAbstractResultsWriter<AccumInteger> {

	@Override
	protected String[] getHeaderLine() {
		String[] headerLine = new String[1];
		headerLine[0] = "Overlap";
		return headerLine;
	}

	public void write(ResultsCategory rc, String[] prefix, AccumInteger results) {

		String[] line = new String[1];
		line[0] = String.valueOf(results.get());

		write(rc, prefix, line);
	}

}
