package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.newTS;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimestampScorer;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.RegressionScorer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_NewTs implements Scorer {

	private final TimestampScorer timestampScorer;

	private final RegressionScorer regressionScorer;

	@Inject
	public Scorer_NewTs(TimestampScorer timestampScorer, RegressionScorer regressionScorer) {

		this.timestampScorer = timestampScorer;
		this.regressionScorer = regressionScorer;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		// return timestampScorer.getScores(learningSet, testingSet);
		return null;
	}

	@Override
	public ScoresContainer getScores(SplitGroupedValues sgvLearning, SplitGroupedValues sgvTesting) {
		ScoresContainer ts = timestampScorer.getScores(sgvLearning, sgvTesting, null);

		// Map<String, ScoresContainer> map = new LinkedHashMap<>();
		// map.put("FIXED", new FixedScore(new Probability(new Accuracy(1.0,
		// 1))));
		// map.put("TS", ts);
		//
		// RegressionScoresClassPropertyId rs =
		// regressionScorer.getClassPropertyId(sgvLearning, map);

		return ts;
	}
}
