package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.pagerank;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.adapters.ranking.RankRepository;
import de.mannheim.uni.expansion.tablefusion.analysis.Accuracy;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.AddedScores;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.FixedScore;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

@Deprecated
public class Scorer_PageRank_with_Base implements Scorer {

	private final RankRepository rankRepository;

	@Inject
	public Scorer_PageRank_with_Base(RankRepository rankRepository) {
		this.rankRepository = rankRepository;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		ScoresContainer main = new FixedScore(new Probability(new Accuracy(1.0, 1)));

		List<ScoresContainer> scoresContainers = new ArrayList<>();

		scoresContainers.add(main);
		scoresContainers.add(rankRepository.getScores(fullSet));

		return new AddedScores(scoresContainers);
	}

}
