package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.fullHierarichal;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_FullHierarchyTS implements Scorer {

	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_FullHierarchyTS(TimeStampsScoringCalculator timeStampsScoringCalculator) {

		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {

		return timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.GET_FULL_HIERARICAL_YEAR);

	}

}
