package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

import java.util.Map;
import java.util.Optional;

public interface WeightsRepository {

	
	double getOrDefault(OptimizableWeight weight);

	Optional<Double> get(OptimizableWeight weight);

	boolean containsWeightsForClass(OptimizableClass clazz);

	Map<OptimizableWeightKey, Double> getWeights();

	public Map<String, Double> getWeights(OptimizableClass optimizableClass);
}
