package de.mannheim.uni.expansion.utils;

import java.net.InetAddress;
import java.net.UnknownHostException;

public class NumOfCpusGetter {

	
	
	static {
		
		
	}
	
	private static final int cpuProcessors = getCpuCountInner();
	
	
	private static int getCpuCountInner() {
		int cpuCount = Runtime.getRuntime().availableProcessors();
		InetAddress ip;
		String hostname;
		try {
			ip = InetAddress.getLocalHost();
			hostname = ip.getHostName();
			
			switch(hostname) {
			
				case "wifo5-13":
					cpuCount = 24;
					break;
				case "dws-06":
					cpuCount = 32;
					break;
			 
			}
			System.out.println("Your current IP address : " + ip);
			System.out.println("Your current Hostname : " + hostname);
			System.out.println("Number of CPUS: " + cpuCount);

		} catch (UnknownHostException e) {

			e.printStackTrace();
		}
		
		return cpuCount;
	}
	
	public static int getProcessors() {
		return cpuProcessors;
	}

}
