package de.mannheim.uni.expansion.utils;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Locale;

public class DecimalFormatter {
	private static final DecimalFormat dfmt = new DecimalFormat("0.00", new DecimalFormatSymbols(Locale.US));

	public static String format(double number) {
		return dfmt.format(number);
	}

	private static final DecimalFormat dfmt3 = new DecimalFormat("0.000", new DecimalFormatSymbols(Locale.US));

	public static String format3(double number) {
		return dfmt3.format(number);
	}
}
