package de.mannheim.uni.expansion.utils;

public class ProbabilityPair implements ValueProbabilityPair {
	private final Object value;
	private final Double score;

	public ProbabilityPair(Object value, Double score) {
		this.value = value;
		this.score = score;
	}

	@Override
	public int compareTo(ValueProbabilityPair o) {
		return Double.compare(score, o.getScore());
	}

	@Override
	public Object getValue() {
		return value;
	}

	@Override
	public Double getScore() {
		return score;
	}

	@Override
	public String toString() {
		return "ProbabilityPair [value=" + value + ", score=" + score + "]";
	}

}