package de.mannheim.uni.expansion.utils;

import java.util.concurrent.ConcurrentHashMap;

public class SimpleConcurrentCache<E, F> {

	private final ConcurrentHashMap<E, F> cache = new ConcurrentHashMap<>();

	public boolean hasCacheFor(E key) {
		return cache.containsKey(key);
	}

	public void add(E key, F value) {
		cache.put(key, value);
	}

	public F get(E key) {
		return cache.get(key);
	}
}
