package de.uni_mannheim.informatik.dws.expansion.wikidata.parser;

import javax.inject.Inject;

import org.json.JSONObject;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.UrlObject;

public class WikidataJSONParserUrl {

	@Inject
	public WikidataJSONParserUrl() {
	}

	public AbstractObject parse(JSONObject jsonObject) {
		if (!"string".equals(jsonObject.get("type"))) {
			throw new IllegalStateException("This is not a JSON Object of the type url.");
		}

		String value = jsonObject.getString("value");

		return new UrlObject(value);
	}

}
