/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.mannheim.uni.matching.optimization;

import de.mannheim.uni.matching.optimization.genetic.GeneticAlgorithm;
import de.mannheim.uni.matching.process.Configuration;
import de.mannheim.uni.matching.process.MatchingComponent;
import de.mannheim.uni.matching.process.ParameterRange;

/**
 *
 * @author domi
 */
public class Optimizer {
    
    private OptimizationAlgorithm algorithm;
    
    public Optimizer(OptimizationAlgorithm algorithm) {
        this.algorithm = algorithm;
    }
    
    public Configuration optimize(MatchingComponent m, ParameterRange parameters) {
        return algorithm.run(parameters, m);
    }    
}
