package de.mannheim.uni.expansion.tablefusion.adapters.columnmatches;

import javax.inject.Inject;
import javax.inject.Named;

import de.mannheim.uni.expansion.columnmatching.CMProperties;

public class ColumnMatchesReader {

	private final String columnMappingsFolder;
	private final CellMatchesReader cellMatchesReader = new CellMatchesReader();

	@Inject
	public ColumnMatchesReader(@Named(CMProperties.COLUMN_MATCHES_FOLDER) String columnMappingsFolder) {
		this.columnMappingsFolder = columnMappingsFolder;
	}

	public ColumnMatchesRepository read() {
		return cellMatchesReader.read(this.columnMappingsFolder
 + "/cell_matches.tar.gz");
	}
}
