package de.mannheim.uni.expansion.tablefusion.adapters.columnmatches;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.CellIdx;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;

public interface ColumnMatchesRepository {

	// public Map<ValueId, InstanceId> getMatches(AnnotatedTableId id);

	public InstanceId getMatch(CellId id);


	public Set<RowIdx> getInstancesWithMatch(AnnotatedTableId id, ColumnIdx columnIdx);

	public Set<ColumnIdx> getPropertiesWithMatch(AnnotatedTableId id, RowIdx rowIdx);

	Map<CellIdx, InstanceId> getMatches(AnnotatedTableId id);

}
