package de.mannheim.uni.expansion.data.ontology.model.repository;

import java.util.List;

import javax.inject.Inject;

public class OntologyAdapterRunner {

	@Inject
	public OntologyAdapterRunner() {

	}

	public OntologyRepositoryImpl run(OntologyRepositoryImpl ontology, List<OntologyAdapter> adapters) {

		for (OntologyAdapter adapter : adapters) {
			ontology = adapter.adapt(ontology);
		}

		return ontology;
	}
}
