package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

public class HostId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final String hostId;

	public HostId(String hostId) {
		this.hostId = hostId;
	}

	public String getHostId() {
		return hostId;
	}

	@Override
	public String toString() {
		return "HostId [hostId=" + hostId + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((hostId == null) ? 0 : hostId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		HostId other = (HostId) obj;
		if (hostId == null) {
			if (other.hostId != null)
				return false;
		} else if (!hostId.equals(other.hostId))
			return false;
		return true;
	}

}
