package de.mannheim.uni.expansion.data.tables.reader;

import com.esotericsoftware.kryo.util.DefaultClassResolver;
import com.esotericsoftware.kryo.util.ObjectMap;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.DomainSource;
import de.mannheim.uni.expansion.data.tables.model.HostId;
import de.mannheim.uni.expansion.data.tables.model.InstanceIndexComposite;
import de.mannheim.uni.expansion.data.tables.model.PropertyIndexComposite;

public class FixedClassResolver extends DefaultClassResolver {
	@SuppressWarnings("rawtypes")
	public FixedClassResolver() {
		if (nameToClass == null)
			nameToClass = new ObjectMap();
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.annotatedtables.model.AnnotatedTableId", AnnotatedTableId.class);
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.annotatedtables.model.AnnotatedTableMetaData", AnnotatedTableMetaData.class);
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.ranking.HostId", HostId.class);
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.annotatedtables.model.DomainSource", DomainSource.class);
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.annotatedtables.model.AnnotatedTableMetaData$InstanceIndexComposite",
				InstanceIndexComposite.class);
		this.nameToClass.put("de.mannheim.uni.expansion.tablefusion.data.annotatedtables.model.AnnotatedTableMetaData$PropertyIndexComposite",
				PropertyIndexComposite.class);
		this.nameToClass.put("de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData$InstanceIndexComposite", InstanceIndexComposite.class);
		this.nameToClass.put("de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData$PropertyIndexComposite", PropertyIndexComposite.class);
		this.nameToClass.put("id", AnnotatedTableId.class);
		this.nameToClass.put("de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId", AnnotatedTableId.class);

	}
}