package de.mannheim.uni.expansion.tablefusion.core.fusing;

import java.util.List;

import de.uni_mannheim.dws.expansion.data.ontology.model.fusedvalue.FusedValue;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valuepairs.AbstractClassPair;

public interface BaseFuser {

	public FusedValue simpleFuse(List<AbstractObject> values);

	public FusedValue fuse(List<? extends AbstractClassPair> values, Double threshold, FusionScoreThresholdAdapter adapter);

	public default FusedValue fuse(List<? extends AbstractClassPair> values) {
		return fuse(values, null, null);
	}

	public boolean checkType(AbstractObject value);

	public FusedValue clusteredFuse(List<AbstractObject> values);
}
