package de.uni_mannheim.informatik.dws.attribute.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class PropertyMapping implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final PropertyId propertyId;
	private final Double score;

	public PropertyMapping(PropertyId propertyId, Double score) {
		super();
		this.propertyId = propertyId;
		this.score = score;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	public Double getScore() {
		return score;
	}

}