package de.uni_mannheim.informatik.dws.expansion.matching;

import de.mannheim.uni.matching.dbpedia.algorithm.KeyIndex;
import de.mannheim.uni.matching.dbpedia.model.MatchingData;
import de.mannheim.uni.matching.dbpedia.model.TableRow;

public class Sample {

	public static void main(String[] args) {

		String dataHome = "C:/Users/yaser/SampleRuns/Wikidata/outputData";

		String kbPath = dataHome + "/kb/";
		String ontologyRepositoryFile = dataHome + "/ontology.kryo";
		String luceneIndexCache = dataHome + "/lucene/";

		KnowledgeBaseAdapter adapter = new KnowledgeBaseAdapter(kbPath, ontologyRepositoryFile, luceneIndexCache);

		MatchingData matchingData = adapter.getMatchingData();

		KeyIndex index = adapter.getLuceneIndex();
		test(matchingData);
	}

	public static void test(MatchingData matchingData) {
		for (TableRow row : matchingData.getDbpediaRowSet()) {
			// int dfsdf = 13;
			// Object help = row.getKey();
			// System.out.println(help);
			// int sdf = 123;
		}
	}
}
