package de.uni_mannheim.informatik.dws.expansion.matching.testing.cases;

import com.google.common.collect.ImmutableMap;
import com.google.common.collect.ImmutableMap.Builder;

import de.uni_mannheim.informatik.dws.expansion.matching.testing.cases.impl.MatchingTestCaseDefault;

public class DefaultTestCases {

	private static ImmutableMap<String, MatchingTestCaseInterface> defaultCases;

	static {
		Builder<String, MatchingTestCaseInterface> builder = ImmutableMap.builder();

		builder.put("DEFAULT", new MatchingTestCaseDefault());

		DefaultTestCases.defaultCases = builder.build();

	}

	public static ImmutableMap<String, MatchingTestCaseInterface> getDefaultCases() {
		return defaultCases;
	}
}
