package de.uni_mannheim.informatik.dws.expansion.matching.testing.cases;

import java.util.List;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.mannheim.uni.tableprocessor.model.json.AnnotatedTable;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;

public interface MatchingTestCaseInterface {

	public List<AnnotatedTable> create(KnowledgeBase knowledgeBase, OntologyRepository ontologyRepository, ClassId setId);

	public Map<String, List<Double>> evaluate(KnowledgeBase knowledgeBase, OntologyRepository ontologyRepository,
			List<Pair<AnnotatedTable, AnnotatedTable>> testAndGeneratedTables);
}
