package expansion.matching;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;

import de.uni_mannheim.informatik.dws.expansion.matching.IndexBuilder;

public class DeAccentTest {

	public static void main(String[] args) {

		Map<String, String> testCandidates = new LinkedHashMap<>();
		testCandidates.put("Chișinău", "Dusseldorf");

		for (Entry<String, String> candidate : testCandidates.entrySet()) {

			Optional<String> ret = IndexBuilder.deAccent(candidate.getKey());
			if (candidate.getValue().equals(candidate.getKey()) && !ret.isPresent()) {
				System.out.println("OK: " + candidate.getKey() + " : " + candidate.getValue());
			} else if (!ret.isPresent()) {
				System.out.println("FAIL: " + candidate.getKey() + " : " + candidate.getKey());
			} else if (!ret.get().equals(candidate.getValue())) {
				System.out.println("FAIL: " + candidate.getKey() + " : '" + ret.get() + "'");
			} else {
				System.out.println("OK: " + candidate.getKey() + " : " + candidate.getValue());
			}
		}
	}

}
