package de.uni_mannheim.dws.expansion.data.ontology.model.objects;

import java.io.Serializable;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public abstract class AbstractObject implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Override
	public abstract int hashCode();

	@Override
	public abstract boolean equals(Object obj);

	public abstract String readableString();

	public abstract ValueType getType();

}
