package de.uni_mannheim.dws.expansion.data.ontology.model.valueholders;

import java.util.List;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class QualifiedAbstractObjectHolder extends QualifiedValueHolder {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final AbstractObject value;

	@Override
	public AbstractObject getValue() {
		return value;
	}

	public QualifiedAbstractObjectHolder(AbstractObject value, List<Qualifier> qualifiers) {
		super(qualifiers);
		this.value = value;

	}

	public QualifiedAbstractObjectHolder(AbstractObject value) {
		super();
		this.value = value;

	}

}
