package de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables;

import java.util.LinkedList;
import java.util.List;

public class AccumLinkedList<E> {

	private final E val;
	private final AccumLinkedList<E> branch1;
	private final AccumLinkedList<E> branch2;

	public AccumLinkedList(AccumLinkedList<E> a, AccumLinkedList<E> b) {
		this.val = null;
		this.branch1 = a;
		this.branch2 = b;
	}

	public AccumLinkedList(E val) {
		this.val = val;
		this.branch1 = null;
		this.branch2 = null;

	}

	public AccumLinkedList() {
		this.val = null;
		this.branch1 = null;
		this.branch2 = null;
	}

	// @Override
	// public Iterator<E> iterator() {
	// return new AccumIterator<>();
	// }

	// private static class AccumIterator<E> implements Iterator<E> {
	//
	// private AccumLinkedNode<E> currentNode;
	//
	// public AccumIterator(AccumLinkedNode<E> node) {
	// this.currentNode = node;
	// }
	//
	// @Override
	// public boolean hasNext() {
	// if (currentNode != null) {
	// return true;
	// } else {
	// return false;
	// }
	// }
	//
	// @Override
	// public E next() {
	// if (currentNode != null) {
	//
	// E ret = currentNode.getValue();
	// currentNode = currentNode.getNext();
	// return ret;
	// } else {
	// return null;
	// }
	//
	// }
	//
	// }

	// private static class AccumLinkedNode<E> {
	//
	// private final E val;
	//
	// private AccumLinkedNode(E val) {
	// super();
	// this.val = val;
	// }
	//
	// private E getValue() {
	// return val;
	// }
	//
	// }

	public List<E> getList() {
		List<E> list = new LinkedList<>();

		LinkedList<AccumLinkedList<E>> stack = new LinkedList<>();
		stack.push(this);

		while (!stack.isEmpty()) {
			AccumLinkedList<E> l = stack.poll();

			if (l.val != null) {
				list.add(l.val);
			}
			if (l.branch1 != null) {
				stack.push(l.branch1);
			}
			if (l.branch2 != null) {
				stack.push(l.branch2);
			}
		}

		return list;
	}

	// public AccumLinkedList<E> copy() {
	// AccumLinkedNode<E> newHead = new AccumLinkedNode<E>(head.val);
	//
	// AccumLinkedNode<E> currentNew = newHead;
	// AccumLinkedNode<E> currentOld = head;
	//
	// while (currentOld.next != null) {
	// AccumLinkedNode<E> node = new AccumLinkedNode<>(currentOld.next.val);
	// currentNew.next = node;
	// currentNew = currentNew.next;
	// currentOld = currentOld.next;
	// }
	// AccumLinkedNode<E> newLast = currentNew;
	// return new AccumLinkedList<>(newHead, newLast);
	// }

}
