package de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators;

import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.AccumInteger;

public class ConcurrentInt extends ConcurrentAccumulator<AccumInteger> {

	public ConcurrentInt(int val) {
		super(new AccumInteger(val));
	}

	public void inc() {
		this.add(new AccumInteger(1));
	}

	public void inc(int val) {
		this.add(new AccumInteger(val));
	}

}
