package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia.musicalWork;

import java.util.HashMap;
import java.util.Optional;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTable;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;

public class TableColumnMapingsClearerer implements AnnotatedTableFilter {

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {
		AnnotatedTable table = data.getTableData();
		AnnotatedTableMetaData md = data.getMetaData();
		md = md.rebuilder().setPropertiesWithScores(new HashMap<>(), new HashMap<>()).build();
		return Optional.of(new AnnotatedTablesReaderData(data.getId(), md, table));

	}

}
