package de.uni_mannheim.informatik.dws.expansion.samples.postMatching;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class TargetMaker {

	public static ClassId getTargetClass(ClassPropertyId classPropertyId) {
		return getTargetClass(classPropertyId.getClassId(), classPropertyId.getPropertyId());
	}

	public static ClassId getTargetClass(ClassId classId, PropertyId propertyId) {
		return new ClassId(classId.getClassId() + "___" + propertyId.getPropertyId() + "___TARGET");
	}
}
