package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.io.IOException;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.informatik.dws.expansion.utils.remote.RepositoryLoading;

public class GsRunRemoteKb {

	public static void main(String[] args) throws IOException {
		Map<ClassId, Set<ClassId>> topClasses = ExtractTablesForGoldStandardRun.getClassesWithHierarchy();
		// topClasses.remove(ClassConstants.single);
		// topClasses.remove(ClassConstants.placeClass);
		// topClasses.add(ClassConstants.placeClass);
		// topClasses.add(ClassConstants.person);
		// topClasses.add(ClassConstants.populatedPlace);

		SetExtension setExtension = new SetExtension(args, topClasses.keySet(), ExtractTablesForGoldStandardRun.getMinPropertyDensity(),
				RepositoryLoading.REMOTE_LOAD_LOCALLY);

		KnowledgeBase kb = setExtension.getGraph().get(KnowledgeBase.class);

		// KeyIndex keyIndex = setExtension.getGraph().get(KeyIndex.class);
		// KnowledgeBase kb = setExtension.getGraph().get(KnowledgeBase.class);
		Scanner in = new Scanner(System.in);
		System.err.flush();
		System.out.println(" |=|  [0] Exit");
		while (true) {
			if (in.hasNextInt()) {
				int a = in.nextInt();

				if (a == 0)
					break;
				else {

				}

			} else {

				System.out.println("Sorry, couldn't understand you!");
				in.next();
			}
		}
		in.close();

	}

}
