package expansion.set.clustering.model;

public class Block {
	private final int block;
	private final double weight;

	public Block(int block, double weight) {
		super();
		this.block = block;
		this.weight = weight;
	}

	public int getBlock() {
		return block;
	}

	public double getWeight() {
		return weight;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + block;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Block))
			return false;
		Block other = (Block) obj;
		if (block != other.block)
			return false;
		return true;
	}

}
