package expansion.set.distant_supervision;

import java.util.List;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.LearnedModelRepository;
import expansion.set.strategies.SetExpansionStrategy;

public interface DS_Clustering_Strategy {

	Map<ClassId, LearnedModelRepository> get(DistantSupervisionInput input);
	
	List<SetExpansionStrategy> getStrategies();
}
