package expansion.set.entitymatching.candidateselection;

import expansion.set.entitymatching.candidateselection.strategies.CandidateSelection_Attribute;
import expansion.set.entitymatching.candidateselection.strategies.CandidateSelection_Label;
import expansion.set.entitymatching.candidateselection.strategies.CandidateSelection_Random;

public class CandidateSelectionStrategies {

	public static CandidateSelectionStrategy LABEL = new CandidateSelectionStrategy("LABEL", CandidateSelection_Label.class);

	public static CandidateSelectionStrategy RANDOM = new CandidateSelectionStrategy("RANDOM", CandidateSelection_Random.class);

	public static CandidateSelectionStrategy ATTRIBUTE = new CandidateSelectionStrategy("ATTRIBUTE", CandidateSelection_Attribute.class);

}
