package expansion.set.entitymatching.matchers;

import expansion.set.entitymatching.matchers.strategies.EntityMatcher_Attribute;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_BOW;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_ImplicitAttribute;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_Indegree;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_Indegree_New;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_Label;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_PrimeLabel;
import expansion.set.entitymatching.matchers.strategies.EntityMatcher_Type;

public class EntityMatcherStrategies {

	public static EntityMatcherStrategy LABEL_SURFACE_FROMS = new EntityMatcherStrategy("LABEL", EntityMatcher_Label.class);
	public static EntityMatcherStrategy PRIME_LABEL = new EntityMatcherStrategy("PRIME_LABEL", EntityMatcher_PrimeLabel.class);
	public static EntityMatcherStrategy ATTRIBUTE = new EntityMatcherStrategy("ATTRIBUTE", EntityMatcher_Attribute.class);
	public static EntityMatcherStrategy TYPE = new EntityMatcherStrategy("TYPE", EntityMatcher_Type.class);
	public static EntityMatcherStrategy BOW = new EntityMatcherStrategy("BOW", EntityMatcher_BOW.class);
	public static EntityMatcherStrategy INDEGREE = new EntityMatcherStrategy("INDEGREE", EntityMatcher_Indegree.class, true);
	public static EntityMatcherStrategy IMPLICIT_ATTRIBUTE = new EntityMatcherStrategy("IMPLICIT_ATTRIBUTE", EntityMatcher_ImplicitAttribute.class);

	public static EntityMatcherStrategy INDEGREE_NEW = new EntityMatcherStrategy("INDEGREE_NEW", EntityMatcher_Indegree_New.class);

}
