package expansion.set.entitymatching.modelLearning;

import java.util.Map;
import java.util.Optional;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.containers.Pair;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.clustering.model.similarities.LearnableRowClusterSimilarities.PairLearningData;
import expansion.set.entitymatching.EntityMatcherFullResults;
import expansion.set.entitymatching.run.EntityMatchingRun;

public interface EntityMatchingModelLearnerRunner {

	public EntityMatchingModel learnModel(EntityMatchingRun run, Set<InstanceId> newEntities,
			Map<RowClusterUUID, Optional<InstanceId>> gsMapped,
			EntityMatcherFullResults fullRun);

	public EntityMatchingModel learnModel(EntityMatchingRun run, Map<Pair<RowClusterUUID, InstanceId>, PairLearningData> pairs,
			EntityMatcherFullResults fullRun, Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> gsMapped);
}
