package expansion.set.entitymatching.modelLearning.weights;

import java.util.Map;
import java.util.Optional;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.containers.Pair;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.clustering.model.similarities.LearnableRowClusterSimilarities.PairLearningData;
import expansion.set.entitymatching.EntityMatcherFullResults;
import expansion.set.entitymatching.modelLearning.EntityMatchingModel;
import expansion.set.entitymatching.modelLearning.weightsGeneric.EM_WeightsGenericEquation;
import expansion.set.entitymatching.modelLearning.weightsGeneric.EM_WeightsGenericLearner;
import expansion.set.entitymatching.run.EntityMatchingRun;

public class EntityMatchingWeightLearner extends EM_WeightsGenericLearner {


	@Inject
	protected EntityMatcherEquation equation;

 
	@Inject
	public EntityMatchingWeightLearner() {

	}


	@Override
	protected EM_WeightsGenericEquation getEquation() {
		return equation;
	}

	@Override
	public EntityMatchingModel learnModel(EntityMatchingRun run, Map<Pair<RowClusterUUID, InstanceId>, PairLearningData> pairs,
			EntityMatcherFullResults fullRun, Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> gsMapped) {
		throw new IllegalStateException();
	}
 
}
