package expansion.set.entitymatching.modelLearning.weka.randomforest;

import javax.inject.Inject;

import com.google.common.collect.Sets;

import expansion.set.entitymatching.matchers.EntityMatcherStrategies;
import expansion.set.entitymatching.modelLearning.weka.EntityMatcherWekaLearner;

public class EntityMatchingWekaRFNew_ET_Learner extends EntityMatcherWekaLearner {
	@Inject
	public EntityMatchingWekaRFNew_ET_Learner() {
		super(Sets.newHashSet(EntityMatcherStrategies.ATTRIBUTE, EntityMatcherStrategies.IMPLICIT_ATTRIBUTE), "RandomForest",
				// new String[] { "-V", "1e-2", "-U", "-M", "8", "-depth", "8",
				// "-attribute-importance", "-store-out-of-bag-predictions",
				// "-I", "900",
				// "-num-slots", "100", "-K", "2" },
				new String[] { "-K", "2", "-U", "-attribute-importance", "-I", "8000", "-num-slots",
						"100", "-B" }, // ,
																			// "-K",
																			// "2",
																			// "-P",
																			// "66"
				true,
				null,
				false, EntityMatcherWekaLearner.DEFAULT_UPSAMPLE, true);
	}
}

// 0.015500396962012334
// Parameters [parameters=[, , -K, 4, -depth, 0, -N, 3, -M, 0, -V, 1e-2, -P, 95,
// -O, -store-out-of-bag-predictions, -I, 150], numeric=false]

//0.015770309883729742
//Parameters [parameters=[, , -K, 6, -depth, 20, -N, 4, -M, 10, -V, 1e-4, -P, 95, -O, -store-out-of-bag-predictions, -I, 150], numeric=false, descretize=true]

//0.015922447717320196
//Parameters [parameters=[, , -K, 2, -depth, 10, -N, 3, -M, 0, -V, 1e-3, -P, 95, -O, -store-out-of-bag-predictions, -I, 150], numeric=false, descretize=true]


// EntityMatchingHyperParameters:
// 0.01439257346925088
// Parameters [parameters=[, , -K, 3, -depth, 5, -N, 3, -M, 10, -V, 1e-4, -P,
// 85, -O, -store-out-of-bag-predictions, -I, 500], numeric=false,
// descretize=true]

// 0.015498543580785222
// Parameters [parameters=[, , -K, 3, -depth, 10, -N, 5, -M, 0, -V, 1e-2, -P,
// 85, -O, -store-out-of-bag-predictions, -I, 500], numeric=false,
// descretize=false]

// 0.014455303497789226
// Parameters [parameters=[, -U, -K, 4, , , -N, 20, , , , , -P, 85, -O,
// -store-out-of-bag-predictions, -I, 150], numeric=false, descretize=false]

// 0.014753412356609001
// Parameters [parameters=[, -U, -K, 3, -depth, 20, -N, 20, -M, 10, -V, 1e-3,
// -P, 85, -O, -store-out-of-bag-predictions, -I, 150], numeric=false,
// descretize=false]

// ClusterHyperParameters:
// 0.001340097342838737
// Parameters [parameters=[, -U, -K, 4, -depth, 0, -N, 0, -M, 0, -V, 1e-4, -P,
// 85, -O, -store-out-of-bag-predictions, -I, 150], numeric=false,
// descretize=false]
