package expansion.set.entitymatching.modelLearning.weka.randomforest;

import javax.inject.Inject;

import com.google.common.collect.Sets;

import expansion.set.entitymatching.matchers.EntityMatcherStrategies;
import expansion.set.entitymatching.modelLearning.simpleWeights.SimpleEntityMatchingWeightLearner;
import expansion.set.entitymatching.modelLearning.weka.EntityMatcherWekaLearner;

public class EntityMatchingWekaRFWithSWLearner extends EntityMatcherWekaLearner {
	@Inject
	public EntityMatchingWekaRFWithSWLearner() {
		super(Sets.newHashSet(EntityMatcherStrategies.ATTRIBUTE, EntityMatcherStrategies.IMPLICIT_ATTRIBUTE), "RandomForest",
				new String[] { "-I", "600", "-num-slots", "100" },
				// new String[] { "-V", "1e-2", "-U", "-M", "8", "-depth", "8",
				// "-attribute-importance", "-store-out-of-bag-predictions",
				// "-I", "3000",
				// "-num-slots", "100", "-K", "2" },
				true,
				SimpleEntityMatchingWeightLearner.class, EntityMatcherWekaLearner.DEFAULT_UPSAMPLE);
	}
}
