package expansion.set.evaluation.matching;

import expansion.set.creation.Entity;

public class ScoredEntity implements Comparable<ScoredEntity> {

	private final Entity entity;
	private final Double score;

	public ScoredEntity(Entity entity, Double score) {
		super();
		this.entity = entity;
		this.score = score;
	}

	public Entity getEntity() {
		return entity;
	}

	public Double getScore() {
		return score;
	}

	@Override
	public int compareTo(ScoredEntity o) {
		return this.getScore().compareTo(o.getScore());
	}

}
