package expansion.set.strategies.clustersplitters.minScoreSplitter;

import java.util.ArrayList;
import java.util.List;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.TrainingData.RecordFeature;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.clustering.model.similarities.LearnableRowClusterSimilarities;

public interface WekaLearnableRowClusterSimilarities extends LearnableRowClusterSimilarities {


	public default double get(TableRowId id1, TableRowId id2, ClassId classId) {
		List<TableRowId> list = new ArrayList<>();
		list.add(id1);
		list.add(id2);

		ClusterEntryKey key = new ClusterEntryKey(0, 1);

		return get(list, classId, key);
	}

	public RecordFeature getFeatureVector(TableRowId id1, TableRowId id2, ClassId classId);

}
