package expansion.set.strategies.clustersplitters.unaryattributes;

import dagger.Module;
import dagger.Provides;

@Module(library = true, complete = false)
public class UnaryAttributeModule {


	private final String unaryAttributeFile;

	public UnaryAttributeModule(String unaryAttributeFile) {
		super();
		this.unaryAttributeFile = unaryAttributeFile;
	}


	@Provides
	UnaryAttributeRepository getRepository(UnaryAttributeAdapter adapter) {
		return new UnaryAttributeRepository(adapter, unaryAttributeFile);
	}

}
