package expansion.set.strategies.evaluatemethod;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public enum CLUSTERING_SIMS_LIST {

	LABEL(CLUSTERING_SIM.LABEL),

	// LABEL_LABELOVERLAP_LABELSF(
	// CLUSTERING_SIM.LABEL,
	// CLUSTERING_SIM.LABELSF,
	// CLUSTERING_SIM.LABELOVERLAP,
	// CLUSTERING_SIM.BOW,
	// CLUSTERING_SIM.PHI,
	// CLUSTERING_SIM.ATTRIBUTE,
	// CLUSTERING_SIM.IMPLICIT,
	// CLUSTERING_SIM.SAME_TABLE),
	LABEL_BOW(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW),
	LABEL_BOW_PHI(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW,
			CLUSTERING_SIM.PHI),
	LABEL_BOW_PHI_ATTRIBUTE(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW,
			CLUSTERING_SIM.PHI,
			CLUSTERING_SIM.ATTRIBUTE),
	LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW,
			CLUSTERING_SIM.PHI,

			CLUSTERING_SIM.ATTRIBUTE,
			CLUSTERING_SIM.IMPLICIT),
	LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW,
			CLUSTERING_SIM.PHI,
			CLUSTERING_SIM.ATTRIBUTE,
			CLUSTERING_SIM.IMPLICIT,
			CLUSTERING_SIM.SAME_TABLE),
	LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE_LABELOVERLAP(
			CLUSTERING_SIM.LABEL,
			// CLUSTERING_SIM.LABELSF,
			CLUSTERING_SIM.LABELOVERLAP,
			CLUSTERING_SIM.BOW,
			CLUSTERING_SIM.PHI,
			CLUSTERING_SIM.ATTRIBUTE,
			CLUSTERING_SIM.IMPLICIT,
			CLUSTERING_SIM.SAME_TABLE);

	private final List<CLUSTERING_SIM> sims;

	private CLUSTERING_SIMS_LIST(CLUSTERING_SIM... sims) {
		this.sims = Collections.unmodifiableList(Arrays.asList(sims));
	}

	public List<CLUSTERING_SIM> getSims() {
		return sims;
	}

}
