package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.couchbase.client.deps.io.netty.util.internal.ThreadLocalRandom;

import expansion.set.strategies.clustersplitters.unaryattributes.UnaryAttributeAdapter;

public class IndexIncrementerTester {

	public static void main(String[] args) {

		Map<Integer, List<String>> map = new HashMap<>();

		ThreadLocalRandom random = ThreadLocalRandom.current();

		int size = random.nextInt(3) + 3;
		for (int i = 0; i < size; i++) {
			int innerSize = random.nextInt(3) + 1;
			List<String> innerList = new ArrayList<>();
			for (int is = 0; is < innerSize; is++) {
				innerList.add("" + i + "_" + is);
			}
			map.put(i, innerList);
		}

		int[] sizes = new int[map.size()];
		int[] currentIndeces = new int[map.size()];

		for (Entry<Integer, List<String>> entry : map.entrySet()) {
			sizes[entry.getKey()] = entry.getValue().size();
		}

		System.out.println(map.toString());
		while (true) {

			for (int ci = 0; ci < currentIndeces.length; ci++) {
				System.out.print(map.get(ci).get(currentIndeces[ci]) + ":::");
			}
			System.out.println();

			boolean continueFor = UnaryAttributeAdapter.incrementIndeces(currentIndeces, sizes, map.size() - 1);

			if (!continueFor) {
				break;
			}

		}

	}

}
