package de.mannheim.uni.expansion.tablefusion.core.similarity.stopwords;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

import javax.inject.Inject;

public class StopWordsAdapter {

	@Inject
	public StopWordsAdapter() {

	}

	public StopWordsRepository read(String file) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(file));
		Set<String> lines = new HashSet<>();
		while (sc.hasNextLine()) {
			lines.add(sc.nextLine());
		}

		sc.close();

		return new StopWordsRepository(lines);
	}
}
