package de.mannheim.uni.expansion.tablefusion.adapters.regressionweights;

import java.util.EnumMap;
import java.util.Map;

import de.mannheim.uni.expansion.tablefusion.core.similarity.Similarity.SimilarityType;

public class RegressionWeightsContainer {

	EnumMap<SimilarityType, RegressionWeightsScores> map;

	public RegressionWeightsContainer(Map<SimilarityType, RegressionWeightsScores> map) {
		this.map = new EnumMap<>(map);
	}

	public RegressionWeightsScores get(SimilarityType type) {
		return map.get(type);
	}

}
