package de.mannheim.uni.expansion.tablefusion.adapters.regressionweights;

public class RegressionWeightsScores {

	private final double instance;
	private final double column;
	private final double table;
	private final double host;
	private final double intercept;

	public RegressionWeightsScores(double instance, double column, double table, double host, Double intercept) {
		super();
		this.instance = instance;
		this.column = column;
		this.table = table;
		this.host = host;
		this.intercept = intercept;
	}

	public double getInstance() {
		return instance;
	}

	public double getColumn() {
		return column;
	}

	public double getTable() {
		return table;
	}

	public double getHost() {
		return host;
	}

	public double getIntercept() {
		return intercept;
	}

}
