package de.mannheim.uni.expansion.tablefusion.adapters.scores;

import de.mannheim.uni.expansion.tablefusion.core.similarity.Similarity.SimilarityType;

public class ScoresOutputEntry {
	private final double instance;
	private final double column;
	private final double table;
	private final double host;
	private final boolean correct;
	private final SimilarityType similarityType;

	public SimilarityType getSimilarityType() {
		return similarityType;
	}

	public ScoresOutputEntry(double instance, double column, double table, double host, boolean correct, SimilarityType similarityType) {
		super();
		this.instance = instance;
		this.column = column;
		this.table = table;
		this.host = host;
		this.correct = correct;
		this.similarityType = similarityType;
	}

	public double getInstance() {
		return instance;
	}

	public double getColumn() {
		return column;
	}

	public double getTable() {
		return table;
	}

	public double getHost() {
		return host;
	}

	public boolean isCorrect() {
		return correct;
	}

}
