package de.mannheim.uni.expansion.tablefusion.analysis.writer;

import de.mannheim.uni.expansion.tablefusion.analysis.stores.PerformancePR;
import de.mannheim.uni.expansion.tablefusion.analysis.stores.performance.PERFMPerformanceI;

public class FullResultsWriter extends AbstractResultsWriter {
	public FullResultsWriter() {
		super();
	}

	@Override
	protected String[] getHeaderLine() {
		String[] headerLine = new String[16];

		headerLine[0] = "TriplesInDbpedia";
		headerLine[1] = "TriplesInWebTables";
		headerLine[2] = "TotalMappedValues";
		headerLine[3] = "MappedTables";
		headerLine[4] = "MappedInstances";
		headerLine[5] = "AverageMappingsPerInstance";
		headerLine[6] = "MedianMappingsPerInstance";

		headerLine[7] = "Correct";
		headerLine[8] = "Wrong";
		headerLine[9] = "MaxCorrect";
		headerLine[10] = "EPercision";
		headerLine[11] = "ERecall";
		headerLine[12] = "EFMeasure";
		headerLine[13] = "New";

		headerLine[14] = "FilteredOut";
		headerLine[15] = "PercentageFilteredOut";

		return headerLine;
	}

	public void write(ResultsCategory rc, String[] prefix, PerformancePR performancePR, PERFMPerformanceI prfmPerformance) {
		String[] line = new String[16];

		line[0] = "TriplesInDbpedia";
		line[1] = "TriplesInWebTables";
		line[2] = "TotalMappedValues";
		line[3] = "MappedTables";
		line[4] = "MappedInstances";
		line[5] = "AverageMappingsPerInstance";
		line[6] = "MedianMappingsPerInstance";

		line[7] = "Correct";
		line[8] = "Wrong";
		line[9] = "MaxCorrect";
		line[10] = "EPercision";
		line[11] = "ERecall";
		line[12] = "EFMeasure";
		line[13] = "New";

		line[14] = "FilteredOut";
		line[15] = "PercentageFilteredOut";

		write(rc, prefix, line);
	}
}
