package de.mannheim.uni.expansion.tablefusion.core.fusing;

import java.util.function.Function;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;
import de.uni_mannheim.dws.expansion.data.ontology.model.fusedvalue.FusedValue;

public interface Fuser {

	public FusedValue fuse(MatchedValues values, TableScores probabilities, double threshold, FusionScoreThresholdAdapter adapter, boolean onePerPLD,
			Function<AnnotatedTableId, String> pldGetter);

	public FusedValue fuseList(MatchedValues values, TableScores probabilities, double threshold);

	// public Object fuse(MatchedValues learningSet, MatchedValues testingSet);
}
