package de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic;

import java.util.function.Function;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.tablefusion.core.fusing.BaseFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ClusterFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.Fuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.FusionScoreThresholdAdapter;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ListFuser;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;
import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityCalculator;
import de.mannheim.uni.expansion.utils.OtsuThresholder;
import de.uni_mannheim.dws.expansion.data.ontology.model.fusedvalue.FusedValue;

public class AbstractWeightedScoreFuser implements Fuser, ListFuser {
	private final SimilarityCalculator sc;
	private final OtsuThresholder otsuThresholder;
	private final ClusterFuser clusterFuser;
	private final BaseFuser baseFuser;

	public AbstractWeightedScoreFuser(SimilarityCalculator sc, OtsuThresholder otsuThresholder, ClusterFuser clusterFuser, BaseFuser simpleFuser) {
		this.sc = sc;
		this.otsuThresholder = otsuThresholder;
		this.clusterFuser = clusterFuser;
		this.baseFuser = simpleFuser;
	}

	// @Override
	// public FusedValue fuse(MatchedValues values, TableScores probabilities,
	// double threshold) {
	//
	// List<AbstractClassPair> list = new ArrayList<>();
	// int accuracyCountSum = 0;
	//
	// for (SingleValue e : values.getValues()) {
	// Probability p = probabilities.get(e.getId());
	// Accuracy accuracy = p.get(SimilarityType.DIRECT);
	// Double probability = accuracy.getAccuracy();
	// if (probability == null || probability.isNaN()) {
	// probability = 0.0;
	//
	// }
	//
	// if (probability > threshold) {
	// accuracyCountSum += p.get(SimilarityType.DIRECT).getTotal();
	// }
	//
	// }
	//
	// for (SingleValue e : values.getValues()) {
	// Probability p = probabilities.get(e.getId());
	// if (p != null) {
	// Accuracy accuracy = p.get(SimilarityType.DIRECT);
	// Double probability = accuracy.getAccuracy();
	// if (probability == null || probability.isNaN()) {
	// probability = 0.0;
	//
	// }
	//
	// if (probability > threshold) {
	// probability = (probability * accuracy.getTotal()) / accuracyCountSum;
	// AbstractObject o = e.getValue();
	//
	// list.add(new ScoreSortedAbstractPair(o, probability));
	//
	// } else {
	// int fdfd = 234324;
	// }
	//
	// } else {
	// int wfsdf = 5;
	// }
	// }
	//
	// // if (probabilitySum > threshold) {
	// return baseFuser.fuse(list, null);
	// // } else {
	// // return null;
	// // }
	// }
	//
	// @Override
	// public FusedValue fuseList(MatchedValues values, TableScores
	// probabilities, double threshold) {
	// SimilarityMeasure sm = sc.getMeasure(values.getDataType());
	//
	// List<ClusterValue> clusterValues = new ArrayList<>();
	//
	// for (SingleValue e : values.getValues()) {
	// Probability p = probabilities.get(e.getId());
	// if (p != null) {
	// Double probability =
	// probabilities.get(e.getId()).get(SimilarityType.LIST_OVERLAP).getAccuracy();
	//
	// if (probability != null) {
	//
	// AbstractObject o = e.getValue();
	//
	// clusterValues.add(new ClusterValue(o, probability));
	//
	// }
	// }
	//
	// }
	//
	// SortedSet<Cluster> clusters = clusterFuser.fuse(clusterValues, baseFuser,
	// sm);
	//
	// clusters = otsuThresholder.threshold(clusters);
	//
	// if (clusters.size() == 0)
	// return null;
	// else
	// return new FusedValue(clusters);
	// }

	@Override
	public FusedValue fuse(MatchedValues values, TableScores probabilities, double threshold, FusionScoreThresholdAdapter adapter, boolean onePerPLD,
			Function<AnnotatedTableId, String> pldGetter) {
		throw new IllegalStateException();
	}

	@Override
	public FusedValue fuseList(MatchedValues values, TableScores probabilities, double threshold) {
		// TODO Auto-generated method stub
		throw new IllegalStateException();
	}

}
