package de.mannheim.uni.expansion.tablefusion.core.scoring;

public class ProbabilitiesCalculatorOld {

	// private final ValueEvaluator valueEvaluator;
	//
	// private final AccuracyCalculator accuracyCalculator;
	//
	// private final AnnotatedTablesRepository annotatedTablesRepository;
	//
	// private final PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId,
	// FusedValue>>> parallelByProperty = new
	// PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId, FusedValue>>>(
	// "ByProperty");
	//
	// private final PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId,
	// FusedValue>>> parallelByTable = new
	// PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId, FusedValue>>>(
	// "ByTable");
	//
	// private final PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId,
	// Object>>> parallelTablePropertyProbabilites = new
	// PersistentParallel3<Entry<AnnotatedTableId, Map<TripleId, Object>>>(
	// "TablePropertyProbabilites");
	//
	// private final PersistentParallel<Entry<TripleId, MatchedValues>>
	// parallelGroupByTabkleId = new PersistentParallel<>("GroupByTableId");
	//
	// private static SimpleConcurrentCache<GroupedValues, ColumnScores> cache =
	// new SimpleConcurrentCache<>();
	//
	// @Inject
	// public ProbabilitiesCalculator(ValueEvaluator valueEvaluator,
	// AccuracyCalculator accuracyCalculator, AnnotatedTablesRepository
	// annotatedTablesRepository) {
	// this.valueEvaluator = valueEvaluator;
	// this.accuracyCalculator = accuracyCalculator;
	// this.annotatedTablesRepository = annotatedTablesRepository;
	// }
	//
	// public TableScoresImpl byTable(GroupedValues map, boolean fuseLists) {
	//
	// Map<AnnotatedTableId, Map<TripleId, FusedValue>> singleValues =
	// groupByTableId(map);
	//
	// ConcurrentHashMap<AnnotatedTableId, Probability> probabilties = new
	// ConcurrentHashMap<AnnotatedTableId, Probability>();
	//
	// try {
	//
	// parallelByTable.foreach(singleValues.entrySet(), new
	// Consumer<Map.Entry<AnnotatedTableId, Map<TripleId, FusedValue>>>() {
	//
	// @Override
	// public void accept(Entry<AnnotatedTableId, Map<TripleId, FusedValue>> e)
	// {
	//
	// EnumMap<SimilarityType, Double> correctMap = new
	// EnumMap<>(SimilarityType.class);
	// EnumMap<SimilarityType, Integer> totalMap = new
	// EnumMap<>(SimilarityType.class);
	//
	// for (Entry<TripleId, FusedValue> value : e.getValue().entrySet()) {
	// Object primitiveV;
	// if (value.getValue().isList())
	// primitiveV = value.getValue().getSimpleList();
	// else
	// primitiveV = value.getValue().getSingle();
	//
	// Similarity similarity = valueEvaluator.getSimilarity(value.getKey(),
	// primitiveV, fuseLists);
	//
	// if (similarity != null) {
	// if (valueEvaluator.correct(similarity, value.getKey())) {
	// Double correct = correctMap.getOrDefault(similarity.getType(), 0.0);
	// correct++;
	// correctMap.put(similarity.getType(), correct);
	// }
	// Integer total = totalMap.getOrDefault(similarity.getType(), 0);
	// total++;
	// totalMap.put(similarity.getType(), total);
	//
	// }
	//
	// }
	//
	// Map<SimilarityType, Accuracy> probabilitiesMap = new
	// EnumMap<>(SimilarityType.class);
	//
	// for (SimilarityType type : SimilarityType.values()) {
	// probabilitiesMap.put(type,
	// new Accuracy(correctMap.getOrDefault(type, 0.0) /
	// totalMap.getOrDefault(type, 0), totalMap.getOrDefault(type, 0)));
	// }
	//
	// probabilties.put(e.getKey(), new Probability(probabilitiesMap));
	//
	// }
	// });
	// } catch (Exception e) {
	// e.printStackTrace();
	// }
	//
	// return new TableScoresImpl(probabilties);
	//
	// }
	//
	// // public HostScores byHost(TableScores tableProbabilities) {
	// //
	// // Map<HostId, List<Probability>> groupedByHost = new HashMap<>();
	// // Map<AnnotatedTableId, HostId> mappings = new HashMap<>();
	// //
	// // for (Entry<AnnotatedTableId, Probability> e :
	// // tableProbabilities.entrySet()) {
	// // AnnotatedTableMetaData metaData =
	// // annotatedTablesRepository.getMetaData(e.getKey());
	// // HostId hostId = metaData.getHostId();
	// // mappings.put(e.getKey(), hostId);
	// // List<Probability> list = groupedByHost.get(hostId);
	// // if (list == null) {
	// // list = new ArrayList<>();
	// // groupedByHost.put(hostId, list);
	// // }
	// // list.add(e.getValue());
	// //
	// // }
	// //
	// // Map<HostId, Probability> hostMap = new HashMap<>();
	// //
	// // for (Entry<HostId, List<Probability>> e : groupedByHost.entrySet()) {
	// // hostMap.put(e.getKey(), new Probability(e.getValue()));
	// // }
	// //
	// // return new HostScores(hostMap, mappings);
	// //
	// // }
	//
	// public ColumnScores byProperty(GroupedValues learningSet) {
	//
	// if (cache.hasCacheFor(learningSet)) {
	// return cache.get(learningSet);
	// } else {
	// Map<AnnotatedTableId, Map<TripleId, FusedValue>> singleValues =
	// groupByTableId(learningSet);
	//
	// ConcurrentHashMap<PropertyId, Map<CellId, Probability>> probabilties =
	// new ConcurrentHashMap<PropertyId, Map<CellId, Probability>>();
	//
	// try {
	//
	// parallelByProperty.foreach(singleValues.entrySet(), new
	// Consumer<Map.Entry<AnnotatedTableId, Map<TripleId, FusedValue>>>() {
	//
	// @Override
	// public void accept(Entry<AnnotatedTableId, Map<TripleId, FusedValue>> e)
	// {
	//
	// FusionPerformance<PrecisionPerformance> results =
	// accuracyCalculator.analyzeAccuracy(e.getValue());
	// for (Entry<ClassPropertyId, PrecisionPerformance> r :
	// results.getPerProperty().entrySet()) {
	//
	// Map<CellId, Probability> propertyMap = getProbabilityMap(probabilties,
	// r.getKey().getPropertyId());
	//
	// propertyMap.put(e.getKey(), new Probability(r.getValue().getAccuracy()));
	//
	// }
	//
	// }
	// });
	// } catch (Exception e) {
	// e.printStackTrace();
	// }
	//
	// ColumnScores cs = new ColumnScores(probabilties);
	//
	// cache.add(learningSet, cs);
	// return cs;
	// }
	// }
	//
	// <T> Map<AnnotatedTableId, Probability>
	// getProbabilityMap(ConcurrentHashMap<T, Map<AnnotatedTableId,
	// Probability>> mapOfMaps, T key) {
	// Map<AnnotatedTableId, Probability> map = mapOfMaps.get(key);
	// if (map == null) {
	// Map<AnnotatedTableId, Probability> newStore = new
	// ConcurrentHashMap<AnnotatedTableId, Probability>();
	// map = mapOfMaps.putIfAbsent(key, newStore);
	// if (map == null) {
	// return newStore;
	// } else {
	// return map;
	// }
	// } else {
	// return map;
	// }
	// }
	//
	// Creator<Map<TripleId, FusedValue>> creator = () -> {
	// return new ConcurrentHashMap<>();
	// };
	//
	// public Map<AnnotatedTableId, Map<TripleId, FusedValue>>
	// groupByTableId(GroupedValues map) {
	// ConcurrentHashMap<AnnotatedTableId, Map<TripleId, FusedValue>>
	// singleValues = new ConcurrentHashMap<AnnotatedTableId, Map<TripleId,
	// FusedValue>>();
	//
	// try {
	// parallelGroupByTabkleId.foreach(map.entrySet(), (e) -> {
	// for (SingleValue value : e.getValue().getValues()) {
	//
	// Map<TripleId, FusedValue> tableMap = CHMHelper.getFromCHM(singleValues,
	// value.getId(), creator);
	//
	// FusedValue fusedValue = FusedValue.fromObject(value.getValue());
	//
	// tableMap.put(e.getKey(), fusedValue);
	//
	// }
	// });
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// return singleValues;
	// }
	//
	// public Map<AnnotatedTableId, Map<TripleId, Object>>
	// groupByTableIdOld(Map<TripleId, MatchedValues> map) {
	// Map<AnnotatedTableId, Map<TripleId, Object>> singleValues = new
	// HashMap<AnnotatedTableId, Map<TripleId, Object>>();
	//
	// for (Entry<TripleId, MatchedValues> e : map.entrySet()) {
	//
	// for (SingleValue value : e.getValue().getValues()) {
	//
	// Map<TripleId, Object> tableMap = singleValues.get(value.getId());
	// if (tableMap == null) {
	// tableMap = new HashMap<TripleId, Object>();
	// singleValues.put(value.getId(), tableMap);
	// }
	// tableMap.put(e.getKey(), value.getValue());
	//
	// }
	//
	// }
	// return singleValues;
	// }
	//
	// // public ScoresContainer weightPropertyProbabilities(ColumnScores
	// // propertyProbabilies, TableScoresImpl tableProbabilites) {
	// //
	// // Map<PropertyIndexComposite, Map<AnnotatedTableId, Probability>> newMap
	// =
	// // new HashMap<PropertyId, Map<AnnotatedTableId, Probability>>();
	// // for (Entry<PropertyIndexComposite, TableScoresImpl> e :
	// // propertyProbabilies.entrySet()) {
	// //
	// // Map<AnnotatedTableId, Probability> newPropertyMap = new
	// // HashMap<AnnotatedTableId, Probability>();
	// // for (Entry<AnnotatedTableId, Probability> oldProperty :
	// // e.getValue().entrySet()) {
	// // AnnotatedTableId tabledId = oldProperty.getKey();
	// // if (tableProbabilites.containsKey(tabledId)) {
	// // newPropertyMap.put(tabledId,
	// // oldProperty.getValue().multiply(tableProbabilites.get(tabledId)));
	// // }
	// //
	// // }
	// //
	// // newMap.put(e.getKey(), newPropertyMap);
	// // }
	// //
	// // return new ColumnScores(newMap);
	// // }
	//
	// // private TableScores getTablePropertyProbabilites(Map<TripleId,
	// // MatchedValues> map, Map<AnnotatedTableId, Probability>
	// // tableProbabilities) {
	// // Map<AnnotatedTableId, Map<TripleId, Object>> singleValues =
	// // groupByTableId(map);
	// //
	// // ConcurrentHashMap<PropertyId, Map<AnnotatedTableId, Probability>>
	// // probabilties = new ConcurrentHashMap<PropertyId, Map<AnnotatedTableId,
	// // Probability>>();
	// //
	// // try {
	// //
	// // parallelTablePropertyProbabilites.foreach(singleValues.entrySet(), new
	// // Consumer<Map.Entry<AnnotatedTableId, Map<TripleId, Object>>>() {
	// //
	// // @Override
	// // public void execute(Entry<AnnotatedTableId, Map<TripleId, Object>> e)
	// {
	// // Probability prob = tableProbabilities.get(e.getKey());
	// // if (prob != null) {
	// //
	// // for (TripleId tripleId : e.getValue().keySet()) {
	// // Map<AnnotatedTableId, Probability> propertyMap =
	// // getProbabilityMap(probabilties, tripleId.getPropertyId());
	// // propertyMap.put(e.getKey(), prob);
	// // }
	// //
	// // }
	// //
	// // }
	// // });
	// // } catch (Exception e) {
	// // e.printStackTrace();
	// // }
	// //
	// // return new TableScores(probabilties);
	// // }
	// //
	// // private HostScores getHostTableProbabilites(Map<TripleId,
	// MatchedValues>
	// // map, Map<HostId, Probability> hostProbabilities) {
	// // Map<AnnotatedTableId, Map<TripleId, Object>> singleValues =
	// // groupByTableId(map);
	// //
	// // Map<PropertyId, Map<AnnotatedTableId, Probability>> probabilties = new
	// // HashMap<PropertyId, Map<AnnotatedTableId, Probability>>();
	// //
	// // for (Entry<AnnotatedTableId, Map<TripleId, Object>> e :
	// // singleValues.entrySet()) {
	// //
	// // Probability prob =
	// //
	// hostProbabilities.get(annotatedTablesRepository.getMetaData(e.getKey()).getHostId());
	// // if (prob != null) {
	// //
	// // for (TripleId tripleId : e.getValue().keySet()) {
	// // Map<AnnotatedTableId, Probability> propertyMap =
	// // probabilties.get(tripleId.getPropertyId());
	// // if (propertyMap == null) {
	// // propertyMap = new HashMap<AnnotatedTableId, Probability>();
	// // probabilties.put(tripleId.getPropertyId(), propertyMap);
	// // }
	// // propertyMap.put(e.getKey(), prob);
	// // }
	// //
	// // }
	// //
	// // }
	// //
	// // return new HostScores(probabilties);
	// // }
	//
	// // public ScoresContainer weightPropertyProbabilitiesByHost(ColumnScores
	// // propertyProbabilies, HostScores hostProbabilities) {
	// // Map<PropertyId, Map<AnnotatedTableId, Probability>> newMap = new
	// // HashMap<PropertyId, Map<AnnotatedTableId, Probability>>();
	// // for (Entry<PropertyId, TableScoresImpl> e :
	// // propertyProbabilies.entrySet()) {
	// //
	// // Map<AnnotatedTableId, Probability> newPropertyMap = new
	// // HashMap<AnnotatedTableId, Probability>();
	// // for (Entry<AnnotatedTableId, Probability> oldProperty :
	// // e.getValue().entrySet()) {
	// // HostId hostId =
	// //
	// annotatedTablesRepository.getMetaData(oldProperty.getKey()).getHostId();
	// // if (hostProbabilities.containsKey(hostId)) {
	// // newPropertyMap.put(oldProperty.getKey(),
	// // oldProperty.getValue().multiply(hostProbabilities.get(hostId)));
	// // }
	// //
	// // }
	// //
	// // newMap.put(e.getKey(), newPropertyMap);
	// // }
	// //
	// // return new ColumnScores(newMap);
	// // }
	//
	// public InstanceScores getInstanceScores(GroupedValues learningSet) {
	//
	// Creator<Map<AnnotatedTableId, Probability>> mapCreator = () -> {
	// return new ConcurrentHashMap<>();
	// };
	//
	// ConcurrentHashMap<InstanceId, Map<AnnotatedTableId, Probability>> map =
	// new ConcurrentHashMap<>();
	//
	// PersistentParallel.runAndFinish(learningSet.entrySet(), (e) -> {
	//
	// Map<AnnotatedTableId, Probability> instanceMap =
	// CHMHelper.getFromCHM(map, e.getKey().getInstanceId(), mapCreator);
	//
	// for (SingleValue sv : e.getValue().getValues()) {
	//
	// AnnotatedTableMetaData md =
	// annotatedTablesRepository.getMetaData(sv.getId());
	//
	// if (md == null) {
	// int asdf = 12334;
	// }
	//
	// double score = md.getScore(e.getKey().getInstanceId());
	//
	// Probability prob = new Probability(new Accuracy(score, 1));
	// instanceMap.put(sv.getId(), prob);
	//
	// }
	//
	// } , "Creating Instance Scores");
	//
	// return new InstanceScores(map);
	// }
	//
	// private Creator<Map<AnnotatedTableId, Probability>> tableMapCreator = ()
	// -> {
	// return new ConcurrentHashMap<>();
	// };
	//
	// // public ScoresContainer weightProbabilities(ColumnScores
	// // columnProbabilities, HostScores hostProbabilities, InstanceScores
	// // instanceScores) {
	// // ConcurrentHashMap<ValueId, Map<AnnotatedTableId, Probability>> newMap
	// =
	// // new ConcurrentHashMap<ValueId, Map<AnnotatedTableId, Probability>>();
	// //
	// // Map<AnnotatedTableId, Map<InstanceId, Probability>> instancesMap =
	// // instanceScores.getByTable();
	// // Map<AnnotatedTableId, Map<PropertyId, Probability>> propertyMap =
	// // columnProbabilities.getByTable();
	// //
	// // Double[] weights = new Double[3];
	// // weights[0] = 0.15;
	// // weights[1] = 0.25;
	// // weights[2] = 0.50;
	// //
	// //
	// PersistentParallel.runAndFinish(annotatedTablesRepository.getAllTableIds(),
	// // (tableId) -> {
	// //
	// // Map<InstanceId, Probability> instancesInnerMap =
	// // instancesMap.get(tableId);
	// // Map<PropertyId, Probability> propertiesInnerMap =
	// // propertyMap.get(tableId);
	// //
	// // HostId hostId =
	// // annotatedTablesRepository.getMetaData(tableId).getHostId();
	// // Probability hostProbability;
	// // if (hostProbabilities.containsKey(hostId)) {
	// // hostProbability = hostProbabilities.get(hostId);
	// // } else {
	// // hostProbability = new Probability(new Accuracy(0.0, 0));
	// // }
	// //
	// // AnnotatedTableMetaData md =
	// // annotatedTablesRepository.getMetaData(tableId);
	// //
	// // for (PropertyId propertyId : md.getProperties().values()) {
	// // for (InstanceId instanceId : md.getInstances().values()) {
	// // Probability instanceProbability = null;
	// // if (instancesInnerMap != null) {
	// // instanceProbability = instancesInnerMap.get(instanceId);
	// // }
	// // if (instanceProbability == null) {
	// // instanceProbability = new Probability(new Accuracy(0.0, 0));
	// // }
	// //
	// // Probability propertyProbability = null;
	// // if (propertiesInnerMap != null) {
	// // propertyProbability = propertiesInnerMap.get(propertyId);
	// // }
	// // if (propertyProbability == null) {
	// // propertyProbability = new Probability(new Accuracy(0.0, 0));
	// // }
	// //
	// // Probability[] probabilities = new Probability[3];
	// // probabilities[0] = hostProbability;
	// // probabilities[1] = instanceProbability;
	// // probabilities[2] = propertyProbability;
	// // Probability probability = new Probability(probabilities, weights);
	// //
	// // CHMHelper.getFromCHM(newMap, new ValueId(instanceId, propertyId),
	// // tableMapCreator).put(tableId, probability);
	// //
	// // }
	// // }
	// //
	// // } , "Create Property - Host - Instance");
	// //
	// // return new FullScores(newMap);
	// // }

}
