package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.AbstractQualifier;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

@Deprecated
public class TableScoresQualifierDecorator implements TableScores {

	private final Set<AbstractQualifier> qualifiers;
	private final TableScores scores;

	public TableScoresQualifierDecorator(TableScores scores, Set<AbstractQualifier> qualifiers) {
		this.qualifiers = qualifiers;
		this.scores = scores;
	}

	@Override
	public Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {

		return scores.get(new CellId(tableId, columnIdx, rowIdx), qualifiers);

		// List<Probability> sum = new ArrayList<>();
		// if (qualifiers.isEmpty()) {
		// return scores.get(tableId, columnIdx, rowIdx);
		// } else {
		// for (Qualifier qualifier : qualifiers) {
		// sum.add(scores.get(tableId, columnIdx, rowIdx, qualifier));
		// }
		// if (sum.size() > 0)
		// return new Probability(sum);
		// else
		// return null;
		// }

	}

	@Override
	public boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.containsKey(new CellId(tableId, columnIdx, rowIdx), qualifiers);
		//
		// if (qualifiers.isEmpty()) {
		// return scores.containsKey(tableId, columnIdx, rowIdx);
		// } else {
		// for (Qualifier qualifier : qualifiers) {
		// if (!scores.containsKey(tableId, columnIdx, rowIdx, qualifier)) {
		// return false;
		// }
		// }
		//
		// return true;
		// }

	}

}
