package de.mannheim.uni.expansion.tablefusion.core.splitting;

import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.QualifiedTripleId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.evaluation.analyzer.PropertiesConfig;

public interface FilteredSplitter extends Splitter {

	public SplitGroupedValues split(GroupedValues groupedValues, Set<QualifiedTripleId> allowedIds);

	public SplitGroupedValues split(GroupedValues groupedValues);

	public SplitGroupedValues split(GroupedValues groupedValues, PropertiesConfig propertiesConfig);

	public SplitGroupedValues split(SplitGroupedValues sgvTesting);

	Set<QualifiedPropertyId> split(ClassId classId, PropertyId propertyId, CellId cellId);

}
