package de.mannheim.uni.expansion.tablefusion.core.splitting;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;

public class NonDuplicateSplitterFactory implements SplitterFactory {
	private final NonDuplicateSplitter splitter;

	@Inject
	public NonDuplicateSplitterFactory(NonDuplicateSplitter splitter) {
		this.splitter = splitter;
	}

	@Override
	public Splitter getSplitter(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return splitter;
	}

}
