package de.mannheim.uni.expansion.tablefusion.core.splitting;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;

public class NonTimeDependentSplitterFactory implements SplitterFactory {
	private final NonTimeDependentSplitter nonTimeDependentSplitter;

	@Inject
	public NonTimeDependentSplitterFactory(NonTimeDependentSplitter nonTimeDependentSplitter) {
		this.nonTimeDependentSplitter = nonTimeDependentSplitter;
	}

	@Override
	public Splitter getSplitter(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return nonTimeDependentSplitter;
	}

}
