package de.mannheim.uni.expansion.tablefusion.core.splitting;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;

public class SimpleSplitterFactory implements SplitterFactory {
	private final SimpleSplitter simpleSplitter;

	@Inject
	public SimpleSplitterFactory(SimpleSplitter simpleSplitter) {
		this.simpleSplitter = simpleSplitter;
	}

	@Override
	public Splitter getSplitter(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return simpleSplitter;
	}

}
