package de.mannheim.uni.expansion.tablefusion.core.splitting;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import com.google.common.collect.BiMap;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.QualifiedTripleId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.TableColumnId;
import de.mannheim.uni.expansion.data.tables.model.timestamp.TimestampIdentifier;
import de.mannheim.uni.expansion.data.tables.model.timestamp.TimestampIdentifier.TimestampType;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimestampScores;
import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.expansion.utils.PersistentParallel4;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.TimeObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.Qualifier;

public class TimestampSplitter implements Splitter {

	private final TimestampScores scores;
	private final AnnotatedTablesRepository repository;

	public TimestampSplitter(AnnotatedTablesRepository repository, TimestampScores scores) {
		this.repository = repository;
		this.scores = scores;
	}

	@Override
	public SplitGroupedValues split(GroupedValues groupedValues) {
		throw new IllegalStateException();
		// ConcurrentHashMap<QualifiedTripleId, MatchedValues> mv = new
		// ConcurrentHashMap<>();
		// PersistentParallel4.runAndFinish(groupedValues.entrySet(), (e) -> {
		// Map<Set<Qualifier>, List<SingleValue>> map = new HashMap<>();
		//
		// for (SingleValue sv : e.getValue().getValues()) {
		// BiMap<PropertyId, TimestampIdentifier> mappings =
		// scores.getMappings(new TableColumnId(sv.getId()));
		// if (mappings != null) {
		// Set<Qualifier> qualifiers = new HashSet<>();
		// for (Entry<PropertyId, TimestampIdentifier> mapping :
		// mappings.entrySet()) {
		// if (TimestampType.PROPAGATED.equals(mapping.getValue().getType())) {
		// qualifiers.add(new Qualifier(mapping.getKey(),
		// TimeObject.fromYear(mapping.getValue().getPropogatedYear())));
		//
		// } else {
		// qualifiers.add(new Qualifier(mapping.getKey(),
		// TimeObject.fromYear(repository.getTimeStamp(sv.getId(),
		// mapping.getValue()))));
		//
		// }
		//
		// }
		//
		// CHMHelper.getFromMap(map, qualifiers, () -> new
		// ArrayList<>()).add(sv);
		// } else {
		// CHMHelper.getFromMap(map, new HashSet<>(), () -> new
		// ArrayList<>()).add(sv);
		// // mv.put(new QualifiedTripleId(e.getKey(), new
		// // HashSet<>()), e.getValue());
		// }
		// }
		// e.getValue().getValues();
		//
		// for (Entry<Set<Qualifier>, List<SingleValue>> me : map.entrySet()) {
		// mv.put(new QualifiedTripleId(e.getKey(), me.getKey()), new
		// MatchedValues(me.getValue(), e.getValue().getDataType()));
		// }
		//
		// } , "SIMPLE SPLITTER");
		//
		// return new SplitGroupedValues(mv);
	}

	@Override
	public Set<QualifiedPropertyId> split(ClassId classId, PropertyId propertyId, CellId cellId) {
		throw new IllegalStateException();
	}

}
