package de.mannheim.uni.expansion.tablefusion.profiling.distribution;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;

public class AnnotatedTablesProfilerRunner {
	private final AnnotatedTablesRepository annotatedTablesRepository;

	@Inject
	public AnnotatedTablesProfilerRunner(AnnotatedTablesRepository annotatedTablesRepository) {
		this.annotatedTablesRepository = annotatedTablesRepository;
	}

	public void run(String resultsFolder) {
		AnnotatedTablesProfiler profiler = new AnnotatedTablesProfiler(annotatedTablesRepository, resultsFolder);
		profiler.run();
	}
}
