package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;
import de.mannheim.uni.expansion.tablefusion.learning.SplitGroupedValuesSets;

public interface Scorer {

	// public ScoresContainer getScores(GroupedValues learningSet);

	// public ScoresContainer getScores(GroupedValues fullSet, GroupedValues
	// learningSet, GroupedValues testingSet);

	public default ScoresContainer getScores(SplitGroupedValuesSets sets) {
		throw new UnsupportedOperationException();
	}

	@Deprecated
	public default ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		throw new UnsupportedOperationException();
	}

	@Deprecated
	public default ScoresContainer getScores(SplitGroupedValues sgvLearning, SplitGroupedValues sgvTesting) {
		throw new UnsupportedOperationException();
	}

}
