package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.analysis.Accuracy;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.FixedScore;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.learning.SplitGroupedValuesSets;

public class Scorer_Baseline implements Scorer {

	@Inject
	public Scorer_Baseline() {
	}

	@Override
	public ScoresContainer getScores(SplitGroupedValuesSets sets) {
		return new FixedScore(new Probability(new Accuracy(1.0, 1)));
	}

}
