package de.uni_mannheim.informatik.ds.expansion.utils.learning;

public class ModelId {

	private final MethodId methodId; 
	private final LearnerId learnerId;
	public ModelId(MethodId methodId, LearnerId learnerId) {
		super();
		this.methodId = methodId;
		this.learnerId = learnerId;
	}
	
	
	
	public MethodId getMethodId() {
		return methodId;
	}



	public LearnerId getLearnerId() {
		return learnerId;
	}



	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((learnerId == null) ? 0 : learnerId.hashCode());
		result = prime * result + ((methodId == null) ? 0 : methodId.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof ModelId))
			return false;
		ModelId other = (ModelId) obj;
		if (learnerId == null) {
			if (other.learnerId != null)
				return false;
		} else if (!learnerId.equals(other.learnerId))
			return false;
		if (methodId == null) {
			if (other.methodId != null)
				return false;
		} else if (!methodId.equals(other.methodId))
			return false;
		return true;
	} 
	
	
	
}
