package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

import java.util.Map;

import de.uni_mannheim.informatik.ds.expansion.utils.learning.LearnedModel;

public class LearnedModelRepository extends GenericLearnedModelRepository<LearnedModel, LearnedModelRepository> {

	public LearnedModelRepository() {
		super();
	}

	public LearnedModelRepository(Map<OptimizableClass, LearnedModel> map) {
		super(map);
	}

	@Override
	protected LearnedModelRepository getFromMap(Map<OptimizableClass, LearnedModel> map) {
		return new LearnedModelRepository(map);
	}

}
