package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

public class OptimizableWeight {

	private final OptimizableWeightKey key;
	private final double defaultValue;

	public OptimizableWeight(OptimizableClass clazz, String name, double defaultValue) {
		super();
		this.key = new OptimizableWeightKey(clazz, name);
		this.defaultValue = defaultValue;
	}

	public OptimizableWeight(OptimizableWeightKey key, double defaultValue) {
		super();
		this.key = key;
		this.defaultValue = defaultValue;
	}

	public OptimizableWeightKey getKey() {
		return key;
	}



	public double getDefaultValue() {
		return defaultValue;
	}

}
