package de.mannheim.uni.expansion.utils;

import java.io.File;

public class MKDIR {
	public static void createDir(File file) throws SecurityException {
		if (!file.exists()) {

			file.mkdir();

		}
	}

	public static void createDirUnchecked(File file) {
		try {
			createDir(file);

		} catch (SecurityException e) {
			throw new IllegalStateException("Unable to create dir: " + file.getAbsolutePath());
		}
	}

	public static boolean createDirBoolean(File file) {
		try {
			createDir(file);
			return true;
		} catch (SecurityException e) {
			return false;
		}
	}
}
