package de.mannheim.uni.matching.dbpedia.model.adapters;

import de.mannheim.uni.matching.MatchingAdapter;
import de.mannheim.uni.matching.dbpedia.model.TableCell;
import de.mannheim.uni.matching.dbpedia.model.TableRow;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 *
 * @author domi
 */
public class TableRowTokenMatchingAdapter extends MatchingAdapter<TableRow> {

    @Override
    public Object getLabel(TableRow instance) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Object getType(TableRow instance) {
        return instance.getTable().getHeader();
    }

    @Override
    public Object getTokens(TableRow instance) {
        List<String> tokens = new ArrayList<>();
        for (TableCell tc : instance.getCells()) {
            String[] tokenStrings = tc.getValue().toString().split("\\s");
            tokens.addAll(Arrays.asList(tokenStrings));
        }
        String[] tokenStrings = instance.getTable().getPageTitle().split("\\s");
        tokens.addAll(Arrays.asList(tokenStrings));

        tokenStrings = instance.getTable().getTableTitle().split("\\s");
        tokens.addAll(Arrays.asList(tokenStrings));
//
//        tokenStrings = instance.getTable().getContextBeforeTable().split("\\s");
//        tokens.addAll(Arrays.asList(tokenStrings));
//
//        tokenStrings = instance.getTable().getContextAfterTable().split("\\s");
//        tokens.addAll(Arrays.asList(tokenStrings));

        return tokens;
    }

}
